define(function() {
    var res_path = "./banner/res/";
	var banner_default_img = res_path + "ic_mainpage_operations_default.png";
	var banner_delete_button = res_path + "ic_mainpage_operations_close.png";
	var bannerView1 = null;
	var bannerView2 = null;
	
	function loadResourceJs(filePath) {
		function createScriptElement(id) {
			var script = document.createElement('script');
			script.id = id;
			script.type = "text/javascript";
			return script;
		}

		var head = document.getElementsByTagName('head').item(0);

		// 加载js文件
		var resouceJs = createScriptElement('resouceJs-banner');
		resouceJs.src = filePath;
		console.log("resourcePath = " + filePath);
		head.appendChild(resouceJs);
	}
	
	function checkBannerData(bannerData) {
		console.log("checkBannerData(), bannerData is " + JSON.stringify(bannerData));
		if (!bannerData) {
			return false;
		}
		if (!bannerData.banners || bannerData.banners.length <= 0) {
			return false;
		}
		return true;
	}
	
	function createBannerView(bannerData) {
		console.log("createBannerView(), bannerData is " + JSON.stringify(bannerData));
		var bannerDiv = document.createElement("div");
		bannerDiv.className = "css_banner_div";
		bannerDiv.picUrl = bannerData.picUrl;
		
		var bannerImage = document.createElement("img");
		bannerImage.className = "css_banner_img";
		
		var bannerDeleteButton = document.createElement("img");
		bannerDeleteButton.className = "css_banner_delete_button";
		bannerDeleteButton.src = banner_delete_button;
		
		//判断是否存在sd卡，若不存在，则直接设置src位图片url；若存在，则根据图片是否下载成功做相应的操作
        var isExternalStorageAvailable = bannerData.isExternalStorageAvailable;
        if (false == isExternalStorageAvailable || "false" == isExternalStorageAvailable) {
        	bannerImage.src = banner_default_img;
        } else {
        	var isPicDownload = bannerData.isPicDownload;
			if (true == isPicDownload) {
				bannerImage.src = bannerData.picUrl;
 			} else {
				bannerImage.src = banner_default_img;
				exec("WidgetMMPContainerComponents", "downloadPic", [bannerData.picUrl]);
			}
        }
        
        //清除运营位的点击事件
        var bannerDivMove = false;
        bannerDiv.addEventListener("touchstart", function() {
			event.stopPropagation();
			console.log("bannerDiv touchstart!");
			moveOverCheck.start(event);
		}, false);
		bannerDiv.addEventListener("touchmove", function() {
			event.stopPropagation();
			console.log("bannerDiv touchmove!");
			if (moveOverCheck.check(event)) {
				bannerDivMove = true;
			}
		}, false);
		bannerDiv.addEventListener("touchend", function() {
			event.stopPropagation();
			console.log("bannerDiv touchend!");
			if (false == bannerDivMove) {
				if (event.target == bannerImage) {
                    var targetString = JSON.stringify(bannerData.target);
                    console.log("click elment is bannerimage, target is " + targetString);
                    exec("WidgetMMPContainerComponents", "clickBanner", [bannerData.id, targetString]);
				} else if (event.target == bannerDeleteButton) {
					console.log("click elment is bannerDeleteButton");
					//删除该运营位
					deleteCard(bannerData.id);
					
					//保存运营位是否显示为false
					cacheMgr.setCache("banner_" + bannerData.id, String("false"));
					
					//记录显示的操作日志
					exec("WidgetMMPContainerComponents", "deleteBanner", [bannerData.id]);
				}
			}
			bannerDivMove = false;
		}, false);
		
		
		//运营位刷新图片
		bannerDiv.refreshBannerImage = function(picUrl) {
			bannerImage.src = picUrl;
		};
		
		bannerDiv.appendChild(bannerImage);
		bannerDiv.appendChild(bannerDeleteButton);
		
		//banner曝光
		var curTime_value = new Date().valueOf();
		var inner_show = document.createElement("img");
		inner_show.className = "css_banner_show_count_statistics";
		inner_show.src = "http://wap.cmread.com/rbc/advertRecord?ln=11_431663_431663_0_ftljtad&t1=16913&cm=M70400D3&vt=3&advertId=linxi_banner&advertPlat=集团&advertType=1&advertActionType=1&time=" + curTime_value;
		var outer_show = document.createElement("img");
		outer_show.className = "css_banner_show_count_statistics";
		outer_show.src = "http://s.trafficjam.cn/s,CMCCtestReaderA8?time=" + curTime_value;
		
		bannerDiv.appendChild(inner_show);
		bannerDiv.appendChild(outer_show);
		
		return bannerDiv;
	}
	
	function createBannersDiv(bannerData) {
		console.log("create banner view, bannerData is " + JSON.stringify(bannerData));
		
		if (null != bannerView1) {
			deleteCard(bannerView1.id);
		}
		if (null != bannerView2) {
			deleteCard(bannerView2.id);
		}
		
		//若缓存数据不为空，则创建运营位视图
		if (checkBannerData(bannerData)) {
			console.log("bannerData is avaliable");
			var showBannerIds = []; //保存记录运营位展示操作日志的数组
			var bannersArray = bannerData.banners;
			console.log("bannersArray length is " + bannersArray.length);
			if (isBannerShow(bannersArray[0].id)) {
				console.log("show is true");
				bannerView1 = createBannerView(bannersArray[0]);
				bannerView1.id = bannersArray[0].id;
				addCard(1, bannerView1);
				//保存要记录操作日志的的运营位id
				showBannerIds.push(bannersArray[0].id);
			}
			
			if (bannersArray.length > 1) {
				if (isBannerShow(bannersArray[1].id)) {
					console.log("show is true 1");
					bannerView2 = createBannerView(bannersArray[1]);
					bannerView2.id = bannersArray[1].id;
					addCard(3, bannerView2);
					//保存要记录操作日志的的运营位id
                    showBannerIds.push(bannersArray[1].id);
				}
			}
			
			//记录运营位展示的操作日志
			if (showBannerIds.length > 0) {
			    exec("WidgetMMPContainerComponents", "addBannersShowLog", [showBannerIds]);
			}
		}
		
		console.log("createBannersDiv end!");
	}
	
	function onResourceLoadFinish() {
		/*if(typeof isLoadFinish == "undefined" || false == isLoadFinish) {
			console.log("onResourceLoadFinish(), isLoadFinish is false");
			setTimeout(function(){
				onResourceLoadFinish();
			}, 50);
			return;
		}*/
        
        //获取缓存的运营位数据
		var bannerData = getResultMessage(exec("WidgetMMPContainerComponents", "getCacheBannerData", []));
		//var dataString = "{\"banners\":[{\"id\":\"1\",\"picUrl\":\"123.jpg\",\"isExternalStorageAvailable\":\"false\"},{\"id\":\"2\",\"picUrl\":\"234.jpg\",\"isExternalStorageAvailable\":\"false\"}]}";
		//bannerData = JSON.parse(dataString);
        
        //创建运营位视图
		createBannersDiv(bannerData);
		
		//请求运营位数据
		exec("WidgetMMPContainerComponents", "requestBannerData", []);
	}
	
	function createBanners() {
		console.log("createBanners()");
		//加载resources.js资源文件
		//loadResourceJs("./banner/resources.js");
			
		//加载business.x.css文件
		xcssParser.parseStyleFile("./banner/business.x.css", onResourceLoadFinish);
	}
	
	function isBannerShow(bannerId) {
		var isShow = cacheMgr.getCache("banner_" + bannerId);
		console.log("isBannerShow() " + bannerId + " is " + isShow);
		if (typeof isShow == "undefined" || "" == isShow) {
			return true;
		}
		if (false == isShow || "false" == isShow) {
			return false;
		}
		return true;
	}
	
	function create(cardDefaultData) {
		console.log("create card begin: " + cardDefaultData.id);
		
		var cardDiv = document.createElement("div");
		cardDiv.id = cardDefaultData.id;
		cardDiv.className= "card";
		cardDiv.innerText = cardDefaultData.name;

		if(cardDefaultData.show){
			var contentDiv = document.createElement("div");
			contentDiv.innerText = "这里是卡片内容";
			cardDiv.appendChild(contentDiv);
			
			//加载卡片内容
			//是否有缓存数据
			
			//是否有默认数据
			
			//请求新数据
		}
		return cardDiv;
	}
	
	//下载图片完成后，更新图片
	function refreshBannerImage(picUrl, downloadPicUrl) {
		console.log("refreshBannerImage, picUrl is " + picUrl + ", downloadPicUrl" + downloadPicUrl);
		if (picUrl == bannerView1.picUrl) {
			bannerView1.refreshBannerImage(downloadPicUrl);
		} else if (picUrl == bannerView2.picUrl) {
			bannerView2.refreshBannerImage(downloadPicUrl);
		}
	}
	
	function refreshBannerView(newBannerData) {
		console.log("refreshBannerView, newBannerData is " + JSON.stringify(newBannerData));
		createBannersDiv(newBannerData);
	}
	
	window.refreshBannerImage = refreshBannerImage;
	window.refreshBannerView = refreshBannerView;
	
	return createBanners;
});