define(function () {
    //常量定义部分
    var DEFAULT_URL = "http://192.168.77.214/Client_Test_developer/Default.aspx?c=N011";

    var ARG_FORCE_AUTH = 1;
    var ARG_NOT_FORCE_AUTH = 0;
    var COMMON_NO_TOKEN_ERROR = "000004";
    var TOKEN_INEFFCTIVE_ERROR = "000001";
    var DEFAULT_ERROR = "999999";
    var WAIT_FOR_AUTH_ERROR = "-100000";
    var ERROR_EXISTING_RUNNING_AUTH = "1007";
    var ic_mainpage_refresh = "./bill/res/ic_mainpage_refresh.png";
    var ic_mainpage_calls = "./bill/res/ic_mainpage_calls.png";
    var ic_mainpage_flow = "./bill/res/ic_mainpage_flow.png";
    var ic_mainpage_time = "./bill/res/ic_mainpage_time.png";
    var ic_callflow_pic = "./bill/res/ic_callflow_pic.png";
    //说法示例小红点
    var ic_viewsample_reddot = "./common/res/ic_viewsample_reddot.png";
    var TELEPHONE_FEE_FOCUS = "telephone_fee";
    var DATA_TRANSFER_FOCUS = "data_transfer";
    var ERROR_VALUE = "----";
    var TIP_NO_NET = "网络无连接，请检测网络设置";
    var TIP_NET_EXCEPTION = "网络异常，请稍后重试";
    var TRAFFIC_UNIT = 1024;
    var TRAFFIC_UNIT_LIMIT = 1023.99;
    var CREDIT_UNIT = 10000;
    var CREDIT_UNIT_LIMIT = 9999.99;
    var VALUE_FIXED_NUMBER = 2;
    var UNIT_MB = "M";
    var UNIT_GB = "G";
    var UNIT_TB = "T";
    var UNIT_MB_OLD = "MB";
    var UNIT_GB_OLD = "GB";
    var UNIT_TB_OLD = "TB";
    var ONE_DAY_IN_MILLIS = 86400000;
    
    var REQUEST_BY_COMMON = 0;
    var REQUEST_BY_VERIFY = 1;
    var request_token_type = 0;
    var VERIFY_MIN_VERSION = 2336;

    //卡片刷新的四种刷新原因
    var UPDATE_TRIGGER_FRAME_LOAD = "frame_load";
    var UPDATE_TRIGGER_FRAME_REFRESH = "frame_refresh";
    var UPDATE_TRIGGER_USER = "user_trigger";
    var UPDATE_TRIGGER_AUTH_SUCC = "auth_succ_trigger";

    var cardContainer =  document.createElement("div");
    //cardContainInner包含title、内容和阴影三部分
    var cardContainInner =  document.createElement("div");
    cardContainInner.className="css_card";
    cardContainer.appendChild(cardContainInner);
    var isCardContentCreated = false;
    var isCssLoaded = false;
    var currentImsi = null;
    var errorCode = DEFAULT_ERROR;
    var isFirstIn = true;

    //结果页面刷新的显示div
    var updateTimeDiv = document.createElement("div");
    var refreshBtnDiv = null;

    var operatorBusinessData = {};

    //更新卡片全局刷新策略的标志位
    var isRequesting = false; //是否正在请求,该定义不能定义于发送方法前，调用之后，否则数据被复位
    var requestCondition = 0;//0:无网络，不需要请求;1:不判断网络，直接请求;2：判断网络，再请求
    var updateTrigger = UPDATE_TRIGGER_FRAME_LOAD; //刷新的来源。框架、用户右上角刷新和错误界面刷新

    //动画控件标识
    var rotateId = null;
    
    //是否需要在数据请求回来后通知框架
    var isNeedNotifyFrame = true;

    var currentErrorCode = DEFAULT_ERROR;
    
    //说法示例界面
    var speechCaseView = null;
    
    //错误置顶界面
    var cardActionView = null;

    //说法示例小红点
    var speechCaseRedDot = null;

    function getFrameTitle() {
        var title = "话费流量";
        if(operatorBusinessData.name) {
            title = operatorBusinessData.name;
            if(title.length > 4) {
                title = title.substring(0,4);
            }
        }
        return title;
    }

    function deleteContentIfIMSIChange() {
        currentImsi = getCurrentIMSI();
        //imsi不相同则删除卡片内容
        if(operatorBusinessData.content && operatorBusinessData.content.imsi != currentImsi) {
            operatorBusinessData.content = null;
            cacheMgr.setCache(operatorBusinessData.id, JSON.stringify(operatorBusinessData));
            console.log("delete stored data for imsi change");
        }

        function getCurrentIMSI() {
            console.log("HFLL_ getCurrentIMSI:");
            var result = exec("lxOvsExtComponents", "getCurrentIMSI", []);
            var realResult = getResultMessage(result);
            console.log("HFLL_ getCurrentIMSI exec : " + realResult);
            return realResult;
        }
    }

    function createCardFrame(defaultData, initNetState) {
        console.log("HFLL_ cmcc business card defaultData: " + JSON.stringify(defaultData));
        if(!defaultData) {
            console.error("HFLL_ defaultData is null");
            return;
        }

        //本地判断是电信联通用户，则默认卡片不显示
        var simTypeResultStr = exec("lxOvsExtComponents","querySimType",[]);
        var simType = getResultMessage(simTypeResultStr);
        console.log("HFLL_ queried simType: " + simType);
        //话费流量卡片非移动用户默认关闭,默认关闭不意味着就是关闭，
        if(simType === "CHINA_UNICOM" || simType === "CHINA_TELECOM") {
            console.log("HFLL_ this card default not show card.");
            defaultData.show = false;
        }


        //读取缓存的卡片数据
        var storedBusinessDataStr = cacheMgr.getCache(defaultData.id);
        console.log("HFLL_ cmcc business card storedBusinessDataStr: " + storedBusinessDataStr);
        var storedBusinessData = null;
        try {
            storedBusinessData = JSON.parse(storedBusinessDataStr);
        }catch (e) {
            console.log("HFLL_ cmcc business card storedBusinessData is not json ");
        }

        if(!storedBusinessData) {
            //如果没有缓存过数据，保存数据
            console.log("HFLL_ cmcc business card store defaultData");
            operatorBusinessData = defaultData;
            cacheMgr.setCache(defaultData.id, JSON.stringify(operatorBusinessData));
        } else if(storedBusinessData && defaultData.version != storedBusinessData.version) {
            //如果当前卡片内容版本不等于卡片版本时，删除数据
            console.log("HFLL_ cmcc business card delete stored data");
            defaultData.show = storedBusinessData.show;
            operatorBusinessData = defaultData;
            cacheMgr.setCache(defaultData.id, JSON.stringify(operatorBusinessData));
        } else {
            //保证卡片title使用默认数据的title
            storedBusinessData.name = defaultData.name;
            storedBusinessData.caseList = defaultData.caseList;
            operatorBusinessData = storedBusinessData;
        }
        deleteContentIfIMSIChange();
        cardContainer.id = operatorBusinessData.id;
        if(operatorBusinessData.show) {
            if (initNetState) {
                requestCondition = 1;
            } else {
                requestCondition = 0;
            }
            xcssParser.parseStyleFile("./bill/business.x.css", handleOperatorBusiness);
        } else {
            listener.callBack(operatorBusinessData.id, CARD_CONTENT_NO_REQUEST);
            cardContainer.style.display = "none";
            requestCondition = 2;
        }

        cardContainer.updateState = function(state) {
            console.log("HFLL_ updateState " + state);
            operatorBusinessData.show = state;
            cacheMgr.setCache(operatorBusinessData.id, JSON.stringify(operatorBusinessData));
            if(state) {
                cardContainer.style.display = "block";
                console.log("HFLL_ updateState: isCardContentCreated: " + isCardContentCreated);
                if(isCardContentCreated) {
                    // do nothing,产品支持再从关到开不用再请求数据，所以只要加载过内容，则使用之前的内容
                } else {
                    if(isCssLoaded) {
                        handleOperatorBusiness();
                    } else {
                        xcssParser.parseStyleFile("./bill/business.x.css", handleOperatorBusiness);
                    }
                }
            } else {
                cardContainer.style.display = "none";
            }
        };
        cardContainer.updateData = function(){
            if (operatorBusinessData.show) {
                sendDataRequest(UPDATE_TRIGGER_FRAME_REFRESH);
            } else {
                if (!isRequesting) {
                    listener.callBack(operatorBusinessData.id, CARD_CONTENT_NO_REQUEST);
                }
            }
        };
        cardContainer.initShowState = operatorBusinessData.show;
        cardContainer.showContentPage = showContent;
        return cardContainer;
    }

	var codeCacheToken = null;
    function sendDataRefreshOrAuth(clickScene) {
        if(TOKEN_INEFFCTIVE_ERROR == errorCode || COMMON_NO_TOKEN_ERROR == errorCode) {
            //鉴权结果监听
            window.onAuthResult = function(tokenId) {
                console.log("HFLL_ onAuthResult: " + tokenId);
                //页面内用户鉴权可能会等很长时间，这时候需要防止用户热插拔SIM卡
                deleteContentIfIMSIChange();
                if(tokenId && tokenId !== "") {
                    //鉴权回来后刷新界面
                    showRefreshingPage();
                    sendDataRequest(UPDATE_TRIGGER_AUTH_SUCC);
                } else {
                    errorCode = COMMON_NO_TOKEN_ERROR;
                    showCacheDataOrErrorPage();
                }
            };
            
            window.onVerifyAuthResult = function(tokenId) {
            	 console.log("HFLL_ onVerifyAuthResult: " + tokenId);
            	 codeCacheToken = tokenId;
            	//鉴权回来后刷新界面
                showRefreshingPage();
                sendDataRequest(UPDATE_TRIGGER_AUTH_SUCC);
            };

            window.onAuthCancel = function() {
                console.log("HFLL_ onAuthCancel ");
                //页面内用户取消鉴权可能会等很长时间，这时候需要防止用户热插拔SIM卡
                deleteContentIfIMSIChange();
                showCacheDataOrErrorPage();
            };

            window.onAuthError = function(errorCodeForAuth) {
                console.log("HFLL_ onAuthError: " + errorCodeForAuth);
                if(ERROR_EXISTING_RUNNING_AUTH == errorCodeForAuth || 1007 == errorCodeForAuth) {
                    console.log("HFLL_ onAuthError: return");
                    return;
                }
                //1003错误表示是网络鉴权错误，所以还要重新鉴权一次，这一次鉴权应该走短信鉴权
                if(1003 == errorCodeForAuth) {
                    console.log("HFLL_ onAuthError: reAuth");
                    exec("AuthComponents", "startAuth", [ARG_NOT_FORCE_AUTH]);
                    showCacheDataOrErrorPage(WAIT_FOR_AUTH_ERROR);
                    return;
                }
                deleteContentIfIMSIChange();
                errorCode = COMMON_NO_TOKEN_ERROR;
                showCacheDataOrErrorPage();
            };
            //鉴权后要从java回调一个请求数据的动作回来
            console.log("HFLL_ startAuth: " + clickScene);
            var authArg = ARG_NOT_FORCE_AUTH;
            if(TOKEN_INEFFCTIVE_ERROR == errorCode) {
                //TOKEN 失效则强制鉴权
                authArg = ARG_FORCE_AUTH;
            }
            if("fail_auto_auth" == clickScene) {
                exec("AuthComponents", "startAuth", [authArg]);
                showCacheDataOrErrorPage(WAIT_FOR_AUTH_ERROR);
            } else {
                //TODO 客户端版本兼容，低版本没有相关API，不展示验证码条目，高度不同，需要适配
        		if(CMCC_CLIENT_APP_VERSION && CMCC_CLIENT_APP_VERSION > VERIFY_MIN_VERSION) {
	                exec("AuthComponents", "startCodeAuthUI", []);
        		} else {
        			exec("AuthComponents", "startAuthUI", [authArg]);
        		}
            }
        } else {
            var tmpNetState = isNetConnect();
            if(!tmpNetState) {
                //没网就不用刷新界面了
                exec("UIComponents", "showToast", [TIP_NO_NET, 1]);
                return;
            }
            if("result_page" != clickScene) {
                showRefreshingPage();
            } else {
                if (updateTimeDiv) {
                    updateTimeDiv.innerText = "正在更新...";
                }
                if (refreshBtnDiv) {
                    refreshBtnDiv.parentNode.disabled = true;
                }
                startLoading(refreshBtnDiv);
            }
            sendDataRequest(UPDATE_TRIGGER_USER);
        }
    }

    function userRightCornerRefresh() {
        console.log("HFLL_ userRightCornerRefresh()");
        sendDataRefreshOrAuth("result_page");
    }

    function cardStickToTop() {
        console.log("HFLL_ cardStickToTop()");
        stickTopSort(operatorBusinessData.id);
    }

    function closeCard() {
        console.log("HFLL_ closeCard()");
    }
    
    function showContent() {
        console.log("HFLL_ showContent()");
        if(speechCaseView) {
            speechCaseView.style.display = "none";
        }
        if(cardActionView) {
            cardActionView.style.display = "none";
        }
        cardContainInner.style.display = "block";
        showCacheDataOrErrorPage();
    }

    function getSpeechCase() {
        var speechCase = operatorBusinessData.caseList;
        if(!speechCase) {
            speechCase = [];
        }
        return speechCase;
    }
    function operateCallBack(callBackId) {
        switch(callBackId) {
            case 0://取消
                showContent();
                break;
            case 1://置顶
                showContent();
                stickTopCardByDom(cardContainer);
                break;
            case 2://关闭
                showCloseConfirmDialogById(cardContainer.id);
                break;
            default:
                break;
        }
    }
    function titleResponseListener(responseId){
        switch(responseId) {
            case 0://点击说法示例区域
                if(speechCaseRedDot) {
                    speechCaseRedDot.style.display = "none";
                }
                if(operatorBusinessData.caseRedDot) {
                    operatorBusinessData.caseRedDot = false;
                    cacheMgr.setCache(operatorBusinessData.id, JSON.stringify(operatorBusinessData));
                }
                recordClickLog("speechCase", null);
                exec("LogComponents", "addCmccLog", [cpaCode.speechCase]);
                if(cardActionView) {
                    cardActionView.style.display = "none";
                }

                cardContainInner.style.display = "none";
                if (speechCaseView) {
                    speechCaseView.style.display = "block";
                } else {
                    speechCaseView = createSpeechCaseView("bill", getFrameTitle(), getSpeechCase());
                    //判断一下是否为空
                    if(speechCaseView) {
                        speechCaseView.setCancelListener(showContent);
                        cardContainer.appendChild(speechCaseView);
                    }
                }
                break;
            case 1://点击置顶箭头按钮
                recordClickLog("menu", null);
                if(speechCaseView) {
                    speechCaseView.style.display = "none";
                }
                cardContainInner.style.display = "none";

                if (cardActionView) {
                    cardActionView.style.display = "block";
                } else {
                    cardActionView = createOperationView("bill", getFrameTitle(), cardContainer.id);
                    //判断一下是否为空
                    if(cardActionView) {
                        cardActionView.setOpListener(operateCallBack);
                        cardContainer.appendChild(cardActionView);
                    }
                }
                break;
            case 2://刷新，暂时没有实现
                break;
            default:
                break;
        }
    }

    function createHeadPart() {
        var headPartRoot = createCardMainTitle(operatorBusinessData.id, operatorBusinessData.name, operatorBusinessData.caseList[0],titleResponseListener, operatorBusinessData.caseRedDot);
        headPartRoot.refreshData = function(isNeedShowRefreshBtn, isNeedShowUpdateTime) {

            //如果不需要显示刷新按钮，则隐藏，如果需要显示则创建或显示
            if(!isNeedShowRefreshBtn) {
                if(headPartRoot.refreshButton) {
                    headPartRoot.refreshButton.style.display = "none";
                    updateTimeDiv.style.display = "none";
                }
            } else {
                if(!headPartRoot.refreshButton) {
                    //右边的刷新按钮区域
                    var refreshButton = document.createElement("img");
                    refreshButton.className = "css_head_part_refreshbtn_div";
                    refreshButton.src = ic_mainpage_refresh;
                    headPartRoot.refreshButton = refreshButton;
                    refreshBtnDiv = refreshButton;
                    
                    var refreshButtonWrapper = document.createElement("div");
                    refreshButtonWrapper.className = "css_head_part_refreshbtn_wrapper_div";
                    refreshButtonWrapper.appendChild(refreshButton);
                    
                    refreshButtonWrapper.clickLogFocus = TELEPHONE_FEE_FOCUS;
                    refreshButtonWrapper.clickLogId = "retryBtn";
                    refreshButtonWrapper.disabled = false;
                    addOnClickListener(refreshButtonWrapper, userRightCornerRefresh);
                    
                    //在菜单按钮前面插入刷新按钮
                    var refreshArea = document.createElement("div");
                    refreshArea.className = "card_main_top_bar_refresh_area";
                    refreshArea.appendChild(refreshButtonWrapper);
                    
                    headPartRoot.appendChild(refreshArea);
                    
                    //在刷新按钮前添加更新时间
                    refreshArea.insertBefore(updateTimeDiv, refreshButtonWrapper);
                } else {
                    stopLoading(headPartRoot.refreshButton);
                    headPartRoot.refreshButton.style.display = "inline";
                    updateTimeDiv.style.display = "inline";
                }
            }
        };

        //创建时两者都不显示
        headPartRoot.refreshData(false, false);

        cardContainInner.headPart = headPartRoot;
        cardContainInner.appendChild(headPartRoot);
    }

    function getUpdateTime(content) {
		var updateTimeInMillis = Date.parse(content.updateTime);
		var currentDate = new Date();
		var currentTimeInMillis = currentDate.getTime();
		var prefix = null;
		var suffix = null;
		if (currentTimeInMillis > updateTimeInMillis) {
			currentDate.setHours(0);
			currentDate.setMinutes(0);
			currentDate.setSeconds(0);
			currentDate.setMilliseconds(0);
			var updateDate = new Date(updateTimeInMillis);
			updateDate.setHours(0);
			updateDate.setMinutes(0);
			updateDate.setSeconds(0);
			updateDate.setMilliseconds(0);
			var temp = (currentDate.getTime() - updateDate.getTime()) / ONE_DAY_IN_MILLIS;
			if (temp != 0) {
				if (temp == 1) {
					prefix = "昨天";
					suffix = "更新";
				} else {
					prefix = "几天前";
					suffix = "更新";
				}
			} else {
				prefix = "";
			}
		} else {
			prefix = "";
		}
		if (suffix == null) {
			var updateDate = new Date(updateTimeInMillis);
			var hoursStr = "" + updateDate.getHours();
			var minutesStr = "" + updateDate.getMinutes();
			if (hoursStr.length == 1) {
				hoursStr = "0" + hoursStr;
			}
			if (minutesStr.length == 1) {
				minutesStr = "0" + minutesStr;
			}
			suffix = hoursStr + ":" + minutesStr + "更新";
		}
		return prefix + suffix;
    }

    function showCacheDataOrErrorPage(errorDesc) {
        if (isOpBusinessDataLegal(operatorBusinessData)) {
            showOperatorBusinessPage();
        } else {
            showErrorPage(errorDesc);
        }
    }
	
    function sendOPBAjaxRequest(handleCardRequestData, handleCardRequestFail, triggerFromScene) {
        console.log("HFLL_ sendOPBAjaxRequest()");
        var requestOptions = {};

        var cardRequestBaseInfo = getBseInfo();

        if (cardRequestBaseInfo && cardRequestBaseInfo.businessRequestUrl) {
            var timeStr = new Date().valueOf();
            requestOptions.url = cardRequestBaseInfo.businessRequestUrl + "?c=1007&gz=0&v=1.0&t=" + timeStr;
        } else {
            if(handleCardRequestFail && typeof handleCardRequestFail == 'function') {
                handleCardRequestFail();
            }
            return;
        }
        
        //requestOptions.url = DEFAULT_URL;

        requestOptions.cmd = "1007";
        requestOptions.onSuccess = handleCardRequestData;
        requestOptions.onFail = handleCardRequestFail;
        requestOptions.timeout = 15000;

        var base = organizeJsonBaseData(cardRequestBaseInfo);
        if(!base){
            base = {};
        }
        
        // if(codeCacheToken) {
	        // base.token = codeCacheToken;
        // }
        request_token_type = REQUEST_BY_COMMON;
        if(cardRequestBaseInfo.verifyToken) {
	        base.token = cardRequestBaseInfo.verifyToken;
	        request_token_type = REQUEST_BY_VERIFY;
	        console.log("HFLL request t_type : " + request_token_type);
        }
         // 如果是用户触发，则加参数mode
		if (triggerFromScene == UPDATE_TRIGGER_USER) {
			// 用户触发则mode参数为0
			base.mode = "0";
		}
 
        var requestJson = {
            "cmd": "1007",
            "base" : base,
            "param":{
                "id":operatorBusinessData.id,
                "version":"" + operatorBusinessData.version,
                "extendParam":{}
            }
        };
        requestOptions.data = JSON.stringify(requestJson);
        //console.log("sendOPBAjaxRequest requestJson: "+ requestOptions.data);
        sendJsonAjaxRequest(requestOptions);
    }

    function sendDataRequest(triggerFromScene) {
        console.log("HFLL_ sendDataRequest() triggerFromScene: " + triggerFromScene + " isRequesting: " + isRequesting);
        if(isRequesting) {
            return;
        }
        updateTrigger = triggerFromScene;

        var netState = isNetConnect();

        if(triggerFromScene == UPDATE_TRIGGER_FRAME_LOAD) {
            console.log("HFLL_ sendDataRequest() requestCondition: " + requestCondition + " netState: " + netState);
            //框架创建时，按首次置的状态决定是否发出请求，包括卡片默认开和卡片后开
            if (1 == requestCondition) {
                //不用判断网络，直接请求，所以往下走即可
                console.log("HFLL_ sendDataRequest() rc1");
            } else if (2 == requestCondition) {
                console.log("HFLL_ sendDataRequest() rc2");
                //需要判断网络，然后决定是否请求，有网则请求
                if (!netState) {
                    console.log("HFLL_ sendDataRequest() rc2n");
                    handleRequestFail(null, triggerFromScene, TIP_NO_NET);
                    return;
                }
            } else {
                handleRequestFail(null, triggerFromScene, TIP_NO_NET);
                return;
            }
        } else {
            //其他情况都判断网络，再决定是否请求
            if (!netState) {
                handleRequestFail(null, triggerFromScene, TIP_NO_NET);
                return;
            }
        }
        if(!isRequesting) {
            isRequesting = true;
        } else {
            //数据正在请求的处理
            console.log("HFLL_ sendDataRequest is requesting");
            return;
        }
        
        isNeedNotifyFrame = true;

        sendOPBAjaxRequest(function (data) {
            isRequesting = false;
            handleRequestSuccess(data, triggerFromScene);
        }, function (data) {
            isRequesting = false;
            handleRequestFail(data, triggerFromScene, TIP_NET_EXCEPTION);
        }, triggerFromScene);
    }

    function handleRequestSuccess(data, triggerFromScene) {
        if (!data) {
            console.log("HFLL_ handleRequestSuccess error 1");
            handleRequestFail(data, triggerFromScene, TIP_NET_EXCEPTION);
            return;
        }
        var returnedData = null;
        try {
            returnedData = JSON.parse(data);
        }catch (e) {
            console.log("HFLL_ returnedData is not json: " + data);
        }
        if(!returnedData) {
            console.log("HFLL_ handleRequestSuccess error 2");
            handleRequestFail(data, triggerFromScene, TIP_NET_EXCEPTION);
            return;
        }
        if (returnedData.status != "success") {
            console.log("HFLL_ handleRequestSuccess error 3");
            handleRequestFail(data, triggerFromScene, TIP_NET_EXCEPTION);
            return;
        }
        //更新时间改为本地时间
        updateLocalTime(returnedData);
        
        //校验返回结果
        if(!isOpBusinessDataLegal(returnedData)) {
            console.log("HFLL_ handleRequestSuccess error 4");
            handleRequestFail(data,triggerFromScene, TIP_NET_EXCEPTION);
            return;
        }
        if(isNeedNotifyFrame) {
            isNeedNotifyFrame = false;
            listener.callBack(operatorBusinessData.id,  CARD_CONTENT_REQUEST_SUCCESS);
        }
        console.log("HFLL_ returnedData.content " + JSON.stringify(returnedData.content));
        
        //根据token类型转换请求结果
        if(request_token_type === REQUEST_BY_VERIFY) {
        	try {
	        	transferResultUrl(returnedData);
        	} catch (transferE) {
        		console.log("HFLL transfer result exception : " + transferE.message);
        	}
        }

        //为下一次用户刷新请求使用
        errorCode = DEFAULT_ERROR;

        console.log("HFLL_ handleRequestSuccess data: " + data);
        operatorBusinessData.content = returnedData.content;
        
        //TODO 验证码鉴权的结果不通知外部
        if(request_token_type !== REQUEST_BY_VERIFY) {
        	//告知话费流量通知栏更新数据
        	exec("lxOvsExtComponents","notifyCallfeesAndFlowDataChanged",[JSON.stringify(returnedData)]);	  	
        }
        request_token_type = REQUEST_BY_COMMON; //恢复默认值
       
        initDataUnit(operatorBusinessData);
        if(operatorBusinessData.content) {
            operatorBusinessData.content.imsi = currentImsi;
        }
        cacheMgr.setCache(operatorBusinessData.id, JSON.stringify(operatorBusinessData));
        if(!operatorBusinessData.show) {
            cardContainer.style.display = "none";
        }
        showOperatorBusinessPage();
    }
    
    Date.prototype.format = function(format){ 
        var o = { 
            "M+" : this.getMonth()+1, //month 
            "d+" : this.getDate(), //day 
            "h+" : this.getHours(), //hour 
            "m+" : this.getMinutes(), //minute 
            "s+" : this.getSeconds(), //second 
            "q+" : Math.floor((this.getMonth()+3)/3), //quarter 
            "S" : this.getMilliseconds() //millisecond 
        };
        
        if(/(y+)/.test(format)) { 
            format = format.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length)); 
        }
        
        for(var k in o) { 
            if(new RegExp("("+ k +")").test(format)) { 
                format = format.replace(RegExp.$1, RegExp.$1.length==1 ? o[k] : ("00"+ o[k]).substr((""+ o[k]).length)); 
            }
        }
        return format; 
    };
   
    function updateLocalTime(data) {
        if(data && data.content) {
            var currTime = new Date().format("yyyy-MM-dd hh:mm:ss");
            data.content.updateTime = currTime; 
        }
    }
    
    function transferResultUrl(data) {
    	if(data && data.content) {
            if(data.content.bottomButton && data.content.bottomButton.length) {//bottomButton是数组
            	for(var i=0; i<data.content.bottomButton.length; i++ ){
            		var moreDetailUrl = data.content.bottomButton[i].url;
	            	if(moreDetailUrl && moreDetailUrl.indexOf("?") > -1) { //链接中存在?符号
	        			data.content.bottomButton[i].url = data.content.bottomButton[i].url + "&c_home_t=" + REQUEST_BY_VERIFY;
	            	} else {
	            		data.content.bottomButton[i].url = data.content.bottomButton[i].url + "?c_home_t=" + REQUEST_BY_VERIFY;
	            	}
            	}
            }
            
            if(data.content.bill && data.content.bill.url) {
            	var billDetailUrl = data.content.bill.url;
            	if(billDetailUrl.indexOf("?") > -1) { //链接中存在?符号
        			data.content.bill.url = data.content.bill.url + "&c_home_t=" + REQUEST_BY_VERIFY;
            	} else {
            		data.content.bill.url = data.content.bill.url + "?c_home_t=" + REQUEST_BY_VERIFY;
            	}
            }
            
            if(data.content.gprs && data.content.gprs.url) {
            	var gprsDetailUrl = data.content.gprs.url;
            	if(gprsDetailUrl.indexOf("?") > -1) { //链接中存在?符号
        			data.content.gprs.url = data.content.gprs.url + "&c_home_t=" + REQUEST_BY_VERIFY;
            	} else {
            		data.content.gprs.url = data.content.gprs.url + "?c_home_t=" + REQUEST_BY_VERIFY;
            	}
            }
            
            if(data.content.speakTime && data.content.speakTime.url) {
            	var speakTimeDetailUrl = data.content.speakTime.url;
            	if(speakTimeDetailUrl.indexOf("?") > -1) { //链接中存在?符号
        			data.content.speakTime.url = data.content.speakTime.url + "&c_home_t=" + REQUEST_BY_VERIFY;
            	} else {
            		data.content.speakTime.url = data.content.speakTime.url + "?c_home_t=" + REQUEST_BY_VERIFY;
            	}
            }
        }
    }

    function handleRequestFail(data, triggerFromScene, netTip) {
        console.log("HFLL_ handleRequestFail data: " + data);
        request_token_type = REQUEST_BY_COMMON; //恢复默认值

        //这里如果有数据表示是校验错误，就不用回调了
        if(isNeedNotifyFrame) {
            isNeedNotifyFrame = false;
            listener.callBack(operatorBusinessData.id, CARD_CONTENT_REQUEST_FAILE);
        }
        
        if(!operatorBusinessData.show) {
            cardContainer.style.display = "none";
        } else {
            //卡片在显示，而且有缓存时，用户触发，需要toast提示
            if(netTip && isOpBusinessDataLegal(operatorBusinessData) && triggerFromScene === UPDATE_TRIGGER_USER) {
                exec("UIComponents", "showToast", [netTip, 1]);
            }
        }
        errorCode = DEFAULT_ERROR;
        try {
            if (data) {
                var jsonData = JSON.parse(data);
                errorCode = jsonData.errorCode;
            }
        } catch (e) {
            console.error("HFLL_ error data is not json");
        }
        var isStartedAuth = startAuthIfNeed();
        if(!isStartedAuth) {
           showCacheDataOrErrorPage();
        }
    }

    function startAuthIfNeed() {
        var result = exec("UIComponents","isNewUserGuide",[]);
        var realResult = getResultMessage(result);
        console.log("HFLL_ startAuthIfNeed exec : " + realResult);
        if (!realResult) {
            if (isFirstIn && (TOKEN_INEFFCTIVE_ERROR == errorCode || COMMON_NO_TOKEN_ERROR == errorCode)) {
                sendDataRefreshOrAuth("fail_auto_auth");
                isFirstIn = false;
                return true;
            }
        } else {
            window.onUserGuideClick = function(result) {
                isFirstIn = false;
                if (TOKEN_INEFFCTIVE_ERROR == errorCode || COMMON_NO_TOKEN_ERROR == errorCode) {
                    sendDataRefreshOrAuth("fail_auto_auth");
                }
            };
        }
        return false;
    }

    function showRefreshingPage() {
        console.log("HFLL_ showRefreshingPage()");
        if(cardContainInner.contentPartContainer.operatorBusinessPageView) {
            cardContainInner.contentPartContainer.operatorBusinessPageView.style.display = "none";
        }
        if(cardContainInner.contentPartContainer.errorPageView) {
            cardContainInner.contentPartContainer.errorPageView.style.display = "none";
        }
        if(cardContainInner.contentPartContainer.refreshingPageView) {
            cardContainInner.contentPartContainer.refreshingPageView.style.display = "block";
            try {
                cardContainInner.contentPartContainer.refreshingPageView.refreshData();
            }catch (e) {
                console.log("HFLL_ contentPartContainer.refreshingPageView.refreshData fail");
            }
        } else {
            var refreshingPage = createOperatorBusinessWaitingView();
            cardContainInner.contentPartContainer.refreshingPageView = refreshingPage;
            cardContainInner.contentPartContainer.appendChild(refreshingPage);
        }

    }

    function showOperatorBusinessPage() {
        console.log("HFLL_ showOperatorBusinessPage() ");
        if(cardContainInner.contentPartContainer.errorPageView) {
            cardContainInner.contentPartContainer.errorPageView.style.display = "none";
        }
        if(cardContainInner.contentPartContainer.refreshingPageView) {
            cardContainInner.contentPartContainer.refreshingPageView.style.display = "none";
        }
        if(cardContainInner.contentPartContainer.operatorBusinessPageView) {
            cardContainInner.contentPartContainer.operatorBusinessPageView.style.display = "block";
            try {
                cardContainInner.contentPartContainer.operatorBusinessPageView.refreshData();
            }catch (e) {
                console.log("HFLL_ contentPartContainer.operatorBusinessPageView.refreshData fail");
            }
        } else {
            var operatorPage = createOperatorBusinessMainPage();
            cardContainInner.contentPartContainer.operatorBusinessPageView = operatorPage;
            cardContainInner.contentPartContainer.appendChild(operatorPage);
        }
    }

    function showErrorPage(errorDesc) {
        console.log("HFLL_ showErrorPage() " + errorDesc);
        if(cardContainInner.contentPartContainer.operatorBusinessPageView) {
            cardContainInner.contentPartContainer.operatorBusinessPageView.style.display = "none";
        }
        if(cardContainInner.contentPartContainer.refreshingPageView) {
            cardContainInner.contentPartContainer.refreshingPageView.style.display = "none";
        }
        var errorCodeShow = errorCode;
        if(errorDesc == WAIT_FOR_AUTH_ERROR) {
            errorCodeShow = errorDesc;
        }
        console.log("HFLL_ errorCodeShow: " + errorCodeShow);
        if(cardContainInner.contentPartContainer.errorPageView) {
            cardContainInner.contentPartContainer.errorPageView.style.display = "block";
            try {
                cardContainInner.contentPartContainer.errorPageView.refreshData(errorCodeShow);
            }catch (e) {
                console.log("HFLL_ contentPartContainer.errorPageView.refreshData fail");
            }
        } else {
            var errorPage = createOperatorBusinessErrorView(errorCodeShow);
            cardContainInner.contentPartContainer.errorPageView = errorPage;
            cardContainInner.contentPartContainer.appendChild(errorPage);
        }
    }

    function isEmptyStr(str) {
        if(!str || str.trim() === "") {
            return true;
        }
        return false;
    }

    function isOpBusinessDataLegal(data) {
        console.log("HFLL_ isOpBusinessDataLegal param: " + JSON.stringify(data));
        try {
            var content = data.content;
            //共同校验
            var detailText = content.bottomButton[0].name;
            console.log("HFLL_ isOpBusinessDataLegal detailText: " + detailText);
            if(isEmptyStr(detailText)) {
                return false;
            }
            var detailUrl = content.bottomButton[0].url;
            console.log("HFLL_ isOpBusinessDataLegal detailUrl: " + detailUrl);
            if(isEmptyStr(detailUrl)) {
                return false;
            }

            var operator = content.operator;
            if(operator == "cmcc") {
                var updateTime = content.updateTime;
                console.log("HFLL_ isOpBusinessDataLegal updateTime: " + updateTime);
                if(isEmptyStr(updateTime)) {
                    return false;
                }

                //解析话费流量
                var isBalanceEmpty = false;
                if(!content.bill) {
                    isBalanceEmpty = true;
                } else {
                    var balance = content.bill.balance;
                    console.log("HFLL_ isOpBusinessDataLegal balance: " + balance);
                    if(isEmptyStr(balance) || isNaN(Number(balance))) {
                        isBalanceEmpty = true;
                    }
                }
                if(isBalanceEmpty) {
                    if(!content.bill) {
                        content.bill = {};
                    }
                    content.bill.balance = ERROR_VALUE;
                    content.bill.unit = "元";
                }
                //解析GPRS
                var isGPRSEmpty = false;
                if(!content.gprs) {
                    isGPRSEmpty = true;
                } else {
                    var gprs = content.gprs.left;
                    console.log("HFLL_ isOpBusinessDataLegal gprs: " + gprs);
                    if(isEmptyStr(gprs) || isNaN(Number(gprs))) {
                        isGPRSEmpty = true;
                    }
                }
                if(isGPRSEmpty) {
                    if(!content.gprs) {
                        content.gprs = {};
                    }
                    content.gprs.left = ERROR_VALUE;
                    content.gprs.unit = UNIT_MB;
                }
                console.log("HFLL_ isBalanceEmpty: " + isBalanceEmpty + " isGPRSEmpty:" + isGPRSEmpty);
                return !(isBalanceEmpty && isGPRSEmpty);
            }

            return true;
        } catch (e) {
            console.log("HFLL_ error happened: " + e);
            return false;
        }
    }

    function initDataUnit(data) {
        try {
            var content = data.content;
            var balance = content.bill.balance;
            var balanceValue = Number(balance);
            if (isNaN(balanceValue)) {
                content.bill.balance = ERROR_VALUE;
                content.bill.unit = "元";
            } else {
                var isBalanceNegativeValue = false;
                if (balanceValue < 0) {
                    isBalanceNegativeValue = true;
                }
                var showBalanceValue = Math.abs(balanceValue);
                if (showBalanceValue > CREDIT_UNIT_LIMIT * CREDIT_UNIT * CREDIT_UNIT) {
                    content.bill.balance = ERROR_VALUE;
                    content.bill.unit = "元";
                } else if (showBalanceValue >= CREDIT_UNIT * CREDIT_UNIT) {
                    showBalanceValue = showBalanceValue / CREDIT_UNIT / CREDIT_UNIT;
                    showBalanceValue = showBalanceValue.toFixed(VALUE_FIXED_NUMBER);
                    if (showBalanceValue > CREDIT_UNIT_LIMIT) {
                        content.bill.balance = ERROR_VALUE;
                        content.bill.unit = "元";
                    } else {
                        content.bill.balance = "" + showBalanceValue;
                        content.bill.unit = "亿元";
                    }
                } else if (showBalanceValue >= CREDIT_UNIT) {
                    showBalanceValue = showBalanceValue / CREDIT_UNIT;
                    showBalanceValue = showBalanceValue.toFixed(VALUE_FIXED_NUMBER);
                    if (showBalanceValue > CREDIT_UNIT_LIMIT) {
                        showBalanceValue = showBalanceValue / CREDIT_UNIT;
                        showBalanceValue = showBalanceValue.toFixed(VALUE_FIXED_NUMBER);
                        content.bill.balance = "" + showBalanceValue;
                        content.bill.unit = "亿元";
                    } else {
                        content.bill.balance = "" + showBalanceValue;
                        content.bill.unit = "万元";
                    }
                } else {
                    showBalanceValue = showBalanceValue.toFixed(VALUE_FIXED_NUMBER);
                    if (showBalanceValue > CREDIT_UNIT_LIMIT) {
                        showBalanceValue = showBalanceValue / CREDIT_UNIT;
                        showBalanceValue = showBalanceValue.toFixed(VALUE_FIXED_NUMBER);
                        content.bill.balance = "" + showBalanceValue;
                        content.bill.unit = "万元";
                    } else {
                        content.bill.balance = "" + showBalanceValue;
                        content.bill.unit = "元";
                    }
                }
                if (isBalanceNegativeValue) {
                    content.bill.balance = "-" + content.bill.balance;  
                }
            }

            var gprs = content.gprs.left;
            var gprsValue = Number(gprs);
            if (isNaN(gprsValue)) {
                content.gprs.left = ERROR_VALUE;
                content.gprs.unit = UNIT_MB;
            } else {
                var isGPRSNegativeValue = false;
                if (gprsValue < 0) {
                    isGPRSNegativeValue = true;
                }
                var showGPRSValue = Math.abs(gprsValue);
                if (showGPRSValue > TRAFFIC_UNIT_LIMIT * TRAFFIC_UNIT * TRAFFIC_UNIT) {
                    content.gprs.left = ERROR_VALUE;
                    content.gprs.unit = UNIT_MB;
                } else if (showGPRSValue >= TRAFFIC_UNIT * TRAFFIC_UNIT) {
                    showGPRSValue = showGPRSValue / TRAFFIC_UNIT / TRAFFIC_UNIT;
                    showGPRSValue = showGPRSValue.toFixed(VALUE_FIXED_NUMBER);
                    if (showGPRSValue > TRAFFIC_UNIT_LIMIT) {
                        content.gprs.left = ERROR_VALUE;
                        content.gprs.unit = UNIT_MB;
                    } else {
                        content.gprs.left = "" + showGPRSValue;
                        content.gprs.unit = UNIT_TB;
                    }
                } else if (showGPRSValue >= TRAFFIC_UNIT) {
                    showGPRSValue = showGPRSValue / TRAFFIC_UNIT;
                    showGPRSValue = showGPRSValue.toFixed(VALUE_FIXED_NUMBER);
                    if (showGPRSValue > TRAFFIC_UNIT_LIMIT) {
                        showGPRSValue = showGPRSValue / TRAFFIC_UNIT;
                        showGPRSValue = showGPRSValue.toFixed(VALUE_FIXED_NUMBER);
                        content.gprs.left = "" + showGPRSValue;
                        content.gprs.unit = UNIT_TB;
                    } else {
                        content.gprs.left = "" + showGPRSValue;
                        content.gprs.unit = UNIT_GB;
                    }
                } else {
                    showGPRSValue = showGPRSValue.toFixed(VALUE_FIXED_NUMBER);
                    if (showGPRSValue > TRAFFIC_UNIT_LIMIT) {
                        showGPRSValue = showGPRSValue / TRAFFIC_UNIT;
                        showGPRSValue = showGPRSValue.toFixed(VALUE_FIXED_NUMBER);
                        content.gprs.left = "" + showGPRSValue;
                        content.gprs.unit = UNIT_GB;
                    } else {
                        content.gprs.left = "" + showGPRSValue;
                        content.gprs.unit = UNIT_MB;
                    }
                }
                if (isGPRSNegativeValue) {
                    content.gprs.left = "-" + content.gprs.left;
                }
            }
        } catch (e) {
            console.log("initDataUnit() error happened " + e);
        }
    }

    function recordClickLog(clickPosId, clickPosFocus) {
        console.log("HFLL_ recordClickLog() param is " + clickPosId + " " + clickPosFocus);
        if( "errorTip" === clickPosId && currentErrorCode === WAIT_FOR_AUTH_ERROR) {
            console.log("HFLL_ waiting auth not need record log");
            return;
        }
        if(clickPosFocus) {
            exec("WidgetMMPContainerComponents", "appenCardCpaLog", [clickPosFocus]);
        }
        if(clickPosId) {
            exec("WidgetMMPContainerComponents", "appenCardOpLog", [cardOpCode.bill, clickPosId]);
        }
    }

    function addOnClickListener(div, func, funcParams, pressColor, bindDiv) {
        if (!div || !func || typeof(func) != "function") {
            return;
        }
        if(!pressColor) {
            pressColor = "";
        }
        if(div.touchStartFunc) {
            div.removeEventListener("touchstart", div.touchStartFunc, false);
        }
        if(div.touchMoveFunc) {
            div.removeEventListener("touchmove",div.touchMoveFunc , false);
        }
        if(div.touchEndFunc) {
            div.removeEventListener("touchend", div.touchEndFunc, false);
        }
        var targetElement = null;
        var touchStartFunc = function () {
            console.log("HFLL_ touchstart: div= " + div);
            event.stopPropagation();
            targetElement = div;
            moveOverCheck.start(event);
            targetElement.style.backgroundColor = pressColor;
            console.log("bind div:" + bindDiv);
            if(bindDiv) {
                bindDiv.style.backgroundColor = pressColor;
            }
        };
        div.touchStartFunc = touchStartFunc;
        div.addEventListener("touchstart",touchStartFunc , false);

        var touchMoveFunc = function () {
            console.log("HFLL_ touchmove: div= " + div);
            event.stopPropagation();
            if (targetElement) {
                targetElement.style.background = "";
                if(bindDiv) {
                    bindDiv.style.backgroundColor = "";
                }
                if (moveOverCheck.check(event)) {
                    console.log("HFLL_ touchmove: div= " + div + " is moveing");
                    targetElement = null;
                }
            }
        };
        div.touchMoveFunc = touchMoveFunc;
        div.addEventListener("touchmove",touchMoveFunc , false);

        var touchEndFunc = function () {
            console.log("HFLL_ touchend: div= " + div);
            event.stopPropagation();
            if (targetElement) {
                // 回调处理
                targetElement.style.background = "";
                if(bindDiv) {
                    bindDiv.style.backgroundColor = "";
                }
                console.log("HFLL_ touchend: div= " + div + " real end");
                recordClickLog(div.clickLogId, div.clickLogFocus);
                func(funcParams);
            }
            targetElement = null;
        };
        div.touchEndFunc = touchEndFunc;
        div.addEventListener("touchend", touchEndFunc, false);
    }

    /********************动画刷新相关***************************/
    function startLoading(refreshBtn) {
        if(!refreshBtn) {
            console.log("HFLL_ startLoading() param not legal");
            return;
        }
        //停止加载动画
        if (rotateId) {
            stopRotateAnimation(rotateId);
            rotateId = null;
        }
        refreshBtn.src = frame_loading_img;
        //开始动画
        rotateId = startRotateAnimation(refreshBtn);
    }

    function stopLoading(refreshBtn) {
        if(!refreshBtn) {
            console.log("HFLL_ stopLoading() param not legal");
            return;
        }
        //停止加载动画
        if (rotateId) {
            stopRotateAnimation(rotateId);
            rotateId = null;
            resetRotateAnimation(refreshBtn);
        }
        refreshBtn.src = ic_mainpage_refresh;
    }

    /**********************界面创建相关*****************************/
    function createOperatorBusinessMainPage() {
        function createContentPart(isCmcc) {
            var contentPartRoot = document.createElement("div");
            contentPartRoot.className = "css_content_part_div";

            contentPartRoot.refreshData = function(isCmcc) {
                if(!contentPartRoot.phoneCreditPart) {
                    var phoneCreditPart = createPhoneCreditPart(isCmcc);
                    contentPartRoot.phoneCreditPart = phoneCreditPart;
                    contentPartRoot.appendChild(phoneCreditPart);
                } else {
                    contentPartRoot.phoneCreditPart.refreshData(isCmcc);
                }
                if(!contentPartRoot.usedTrafficPart) {
                    var usedTrafficPart = createUsedTrafficPart(isCmcc);
                    contentPartRoot.usedTrafficPart = usedTrafficPart;
                    contentPartRoot.appendChild(usedTrafficPart);
                } else {
                    contentPartRoot.usedTrafficPart.refreshData(isCmcc);
                }
                //移动用户才创建，因为不会有短信查"通话"
                if(isCmcc) {
	                if(!contentPartRoot.speakTimePart) {
	                    var speakTimePart = createSpeakTimePart(isCmcc);
	                    contentPartRoot.speakTimePart = speakTimePart;
	                    contentPartRoot.appendChild(speakTimePart);
	                } else {
	                    contentPartRoot.speakTimePart.refreshData(isCmcc);
	                }                	
                } else {
	                if(contentPartRoot.speakTimePart) {
	                    contentPartRoot.removeChild(speakTimePart);
	                }
                }
            };
            contentPartRoot.refreshData(isCmcc);
            return contentPartRoot;
        }

		//创建通话时长区域
		function createSpeakTimePart(isCmcc) {
			var speakTimePartRoot = document.createElement("div");
			speakTimePartRoot.className = "css_content_part_speaktime_part_div";
			speakTimePartRoot.refreshData = function(isCmcc) {
                if(!speakTimePartRoot.speakTimeClickCmccPartRoot) {
                    var speakTimeClickCmccPartRoot = document.createElement("div");
                    speakTimeClickCmccPartRoot.className = "css_content_part_speaktime_click_cmcc_part_div";
                    speakTimePartRoot.speakTimeClickCmccPartRoot = speakTimeClickCmccPartRoot;
                    speakTimePartRoot.appendChild(speakTimeClickCmccPartRoot);

                    var speakTimeCenterWrapperCmcc = createSingleLinePart();
                    speakTimeClickCmccPartRoot.appendChild(speakTimeCenterWrapperCmcc);
                    
                    speakTimeCenterWrapperCmcc.titleIc.src = ic_mainpage_time;
                    
                    speakTimeCenterWrapperCmcc.titleArea.innerText = "通话";
                    
                    speakTimeCenterWrapperCmcc.contentArea.innerText = "剩余";
                    speakTimePartRoot.contentArea = speakTimeCenterWrapperCmcc.contentArea;
                    
                    speakTimeCenterWrapperCmcc.valueArea.innerText = "200";
                    speakTimePartRoot.valueArea = speakTimeCenterWrapperCmcc.valueArea;
                    
                    speakTimeCenterWrapperCmcc.unitArea.innerText = "分钟";
                    speakTimePartRoot.unitArea = speakTimeCenterWrapperCmcc.unitArea;

                    speakTimeCenterWrapperCmcc.buttonArea.parentNode.style.display = "none";

                    speakTimeClickCmccPartRoot.clickLogId = "cmccSpeakTime";
                    addOnClickListener(speakTimeClickCmccPartRoot, goToSpeakTimePage, null ,"#efefef");
                } else {
                	speakTimePartRoot.speakTimeClickCmccPartRoot.style.display = "block";
                }
                if(!operatorBusinessData.content.speakTime) {
                	speakTimePartRoot.speakTimeClickCmccPartRoot.style.display = "none";
                } else {
	                //填充数据
	                var isNeedShowRed = false;
	                var speakTime = getSpeakTime(operatorBusinessData.content);
	                if(isEmptyStr(speakTime) || isNaN(speakTime)) {
	                    speakTimePartRoot.valueArea.innerText = ERROR_VALUE;
	                } else {
	                	var speakTimeNum = parseInt(speakTime);
	                	if(speakTimeNum < 0) {
	                	    isNeedShowRed = true;
	                	}
	                	speakTimePartRoot.valueArea.innerText = Math.abs(speakTimeNum);
	                }
	                if(isNeedShowRed) {
	                    speakTimePartRoot.valueArea.className = "content_part_single_line_value_red";
	                    speakTimePartRoot.unitArea.className = "content_part_single_line_unit_red";
	                    speakTimePartRoot.contentArea.className = "content_part_single_line_content_red";
	                    speakTimePartRoot.contentArea.innerText = "超出";
	                } else {
                        speakTimePartRoot.valueArea.className = "content_part_single_line_value";
                        speakTimePartRoot.unitArea.className = "content_part_single_line_unit";
                        speakTimePartRoot.contentArea.className = "content_part_single_line_content";
                        speakTimePartRoot.contentArea.innerText = "剩余";
	                }
                }
			};
            speakTimePartRoot.refreshData(isCmcc);
            return speakTimePartRoot;
		}

        function createPhoneCreditPart(isCmcc) {
            var phoneCreditPartRoot = document.createElement("div");
            if(!isCmcc) {
            	phoneCreditPartRoot.className = "css_content_part_phonecredit_part_div";
            } else {
            	phoneCreditPartRoot.className = "css_content_part_phonecredit_part_div_cmcc";
            }

            phoneCreditPartRoot.refreshData = function(isCmcc) {
                if(isCmcc) {
                    if(phoneCreditPartRoot.phoneCreditClickNonCmccPartRoot) {
                        phoneCreditPartRoot.phoneCreditClickNonCmccPartRoot.style.display = "none";
                    }
                    if(!phoneCreditPartRoot.phoneCreditClickCmccPartRoot) {
                        var phoneCreditClickCmccPartRoot = document.createElement("div");
                        phoneCreditClickCmccPartRoot.className = "css_content_part_phonecredit_click_cmcc_part_div";
                        phoneCreditPartRoot.phoneCreditClickCmccPartRoot = phoneCreditClickCmccPartRoot;
                        phoneCreditPartRoot.appendChild(phoneCreditClickCmccPartRoot);

                        var phoneCreditCenterWrapperCmcc = createSingleLinePart();
                        phoneCreditCenterWrapperCmcc.className = "content_part_single_line_root_no_border";
                        phoneCreditClickCmccPartRoot.appendChild(phoneCreditCenterWrapperCmcc);

						phoneCreditCenterWrapperCmcc.titleIc.src = ic_mainpage_calls;
						
                        phoneCreditCenterWrapperCmcc.titleArea.innerText = "话费";

                        phoneCreditCenterWrapperCmcc.valueArea.addEventListener("click", function(){}, false);
                        phoneCreditPartRoot.phoneCreditVauleDiv = phoneCreditCenterWrapperCmcc.valueArea;

                        phoneCreditCenterWrapperCmcc.contentArea.innerText = "剩余";
                        phoneCreditPartRoot.contentArea = phoneCreditCenterWrapperCmcc.contentArea;
                        
                        phoneCreditCenterWrapperCmcc.unitArea.innerText = "元";
                        phoneCreditPartRoot.phoneCreditUnit = phoneCreditCenterWrapperCmcc.unitArea;
                        
                        updateTimeDiv.className = "css_head_part_updatetime_div";
                        updateTimeDiv.addEventListener("click", function(){}, false);
                        
                        phoneCreditCenterWrapperCmcc.buttonArea.innerText = "充话费";
                        phoneCreditPartRoot.feeChargeBtn = phoneCreditCenterWrapperCmcc.buttonArea;      
                        
                        phoneCreditClickCmccPartRoot.clickLogFocus = TELEPHONE_FEE_FOCUS;
                        phoneCreditClickCmccPartRoot.clickLogId = "cmccCredit";
                        addOnClickListener(phoneCreditClickCmccPartRoot, goToPhoneCreditDetailPage, null ,"#efefef");
                        phoneCreditCenterWrapperCmcc.buttonArea.parentNode.clickLogId = "cmccCreditCharge";
                        addOnClickListener(phoneCreditCenterWrapperCmcc.buttonArea.parentNode, goToFeeChargePage, null , null);
                    } else {
                        phoneCreditPartRoot.phoneCreditClickCmccPartRoot.style.display = "block";
                    }
                    var phoneCredit = getPhoneCredit(operatorBusinessData.content);
                    var numberCredit = Number(phoneCredit);
                    if(phoneCredit.indexOf("-") == 0 && phoneCredit.indexOf("--") != 0) {
                    	phoneCredit = phoneCredit.substring(1);
                    }
                    phoneCreditPartRoot.phoneCreditVauleDiv.innerText = phoneCredit;
                    phoneCreditPartRoot.phoneCreditUnit.innerText = getPhoneCreditUnit(operatorBusinessData.content);
                    var isNeedShowRed = false;
                    if(!isNaN(numberCredit)) {
                        if(numberCredit < 0) {
                            isNeedShowRed = true;
                        }
                    }
                    if(isNeedShowRed) {
                        phoneCreditPartRoot.phoneCreditVauleDiv.className = "content_part_single_line_value_red";
                        phoneCreditPartRoot.phoneCreditUnit.className = "content_part_single_line_unit_red";
                        phoneCreditPartRoot.contentArea.className = "content_part_single_line_content_red";
                        phoneCreditPartRoot.contentArea.innerText = "欠费";
                    } else {
                        phoneCreditPartRoot.phoneCreditVauleDiv.className = "content_part_single_line_value";
                        phoneCreditPartRoot.phoneCreditUnit.className = "content_part_single_line_unit";
                        phoneCreditPartRoot.contentArea.className = "content_part_single_line_content";
                        phoneCreditPartRoot.contentArea.innerText = "剩余";
                    }
                    
                    //如果不需要显示更新时间，则隐藏，否则创建或显示之
                    updateTimeDiv.innerText = getUpdateTime(operatorBusinessData.content);
                    
                    //设置充话费按钮
                    phoneCreditPartRoot.feeChargeBtn.innerText = getFeeChargeBtnName(operatorBusinessData.content);
                } else {
                    //非移动结果展示
                    if(phoneCreditPartRoot.phoneCreditClickCmccPartRoot) {
                        phoneCreditPartRoot.phoneCreditClickCmccPartRoot.style.display = "none";
                    }
                    if(!phoneCreditPartRoot.phoneCreditClickNonCmccPartRoot) {
                        var phoneCreditClickNonCmccPartRoot = document.createElement("div");
                        phoneCreditClickNonCmccPartRoot.className = "css_content_part_phonecredit_click_noncmcc_part_div";
                        phoneCreditPartRoot.phoneCreditClickNonCmccPartRoot = phoneCreditClickNonCmccPartRoot;
                        phoneCreditPartRoot.appendChild(phoneCreditClickNonCmccPartRoot);
                        var phoneCreditCenterWrapperNonCmcc = document.createElement("div");
                        phoneCreditCenterWrapperNonCmcc.className = "css_content_part_phonecredit_centerwrapper_noncmcc_div";
                        phoneCreditClickNonCmccPartRoot.appendChild(phoneCreditCenterWrapperNonCmcc);

                        var phoneCreditQueryImgDiv = document.createElement("img");
                        phoneCreditQueryImgDiv.className = "css_content_part_phonecredit_part_phonecreditqueryimg_div";
                        phoneCreditQueryImgDiv.src = ic_mainpage_calls;
                        phoneCreditCenterWrapperNonCmcc.appendChild(phoneCreditQueryImgDiv);

                        var phoneCreditQueryTextDiv = document.createElement("div");
                        phoneCreditQueryTextDiv.className = "css_content_part_phonecredit_part_phonecreditquerytext_div";
                        phoneCreditQueryTextDiv.innerText = "短信查话费";
                        phoneCreditCenterWrapperNonCmcc.appendChild(phoneCreditQueryTextDiv);
                        
                        phoneCreditClickNonCmccPartRoot.clickLogFocus = TELEPHONE_FEE_FOCUS;
                        phoneCreditClickNonCmccPartRoot.clickLogId = "noncmccCredit";
                        addOnClickListener(phoneCreditClickNonCmccPartRoot, smsQueryPhoneCredit, null, "#efefef");
                    } else {
                        phoneCreditPartRoot.phoneCreditClickNonCmccPartRoot.style.display = "block";
                    }
                }
            };
            phoneCreditPartRoot.refreshData(isCmcc);
            return phoneCreditPartRoot;
        }

        function createUsedTrafficPart(isCmcc) {
            var usedTrafficPartRoot = document.createElement("div");
            if(!isCmcc) {
            	usedTrafficPartRoot.className = "css_content_part_usedtraffic_part_div";            	
            } else {
            	usedTrafficPartRoot.className = "css_content_part_usedtraffic_part_div_cmcc";
            }
            usedTrafficPartRoot.refreshData = function(isCmcc) {
                if(isCmcc) {
                    if(usedTrafficPartRoot.usedTrafficClickNonCmccPartRoot) {
                        usedTrafficPartRoot.usedTrafficClickNonCmccPartRoot.style.display = "none";
                    }
                    if(!usedTrafficPartRoot.usedTrafficClickCmccPartRoot) {
                        var usedTrafficClickCmccPartRoot = document.createElement("div");
                        usedTrafficClickCmccPartRoot.className = "css_content_part_usedtraffic_click_cmcc_part_div";
                        usedTrafficPartRoot.usedTrafficClickCmccPartRoot = usedTrafficClickCmccPartRoot;
                        usedTrafficPartRoot.appendChild(usedTrafficClickCmccPartRoot);
                        var usedTrafficCenterWrapperCmcc = createSingleLinePart();
                        usedTrafficClickCmccPartRoot.appendChild(usedTrafficCenterWrapperCmcc);
                        
                        usedTrafficCenterWrapperCmcc.titleIc.src = ic_mainpage_flow;
                        
                        usedTrafficCenterWrapperCmcc.titleArea.innerText = "流量";
                        
                        usedTrafficCenterWrapperCmcc.valueArea.addEventListener("click", function(){}, false);
                        usedTrafficPartRoot.usedTrafficVauleDiv = usedTrafficCenterWrapperCmcc.valueArea;
                        
                        usedTrafficCenterWrapperCmcc.contentArea.innerText = "剩余";
                        usedTrafficPartRoot.contentArea = usedTrafficCenterWrapperCmcc.contentArea;
                        
                        usedTrafficCenterWrapperCmcc.unitArea.innerText = UNIT_MB;
                        usedTrafficPartRoot.usedTrafficUnit = usedTrafficCenterWrapperCmcc.unitArea;
                        
                        usedTrafficCenterWrapperCmcc.buttonArea.innerText = "买流量";
                        usedTrafficPartRoot.flowChargeBtn = usedTrafficCenterWrapperCmcc.buttonArea;
                        
                        usedTrafficClickCmccPartRoot.clickLogFocus = DATA_TRANSFER_FOCUS;
                        usedTrafficClickCmccPartRoot.clickLogId = "cmccTraffic";
						addOnClickListener(usedTrafficClickCmccPartRoot, goToUsedTrafficDetailPage, null, "#efefef");
                        usedTrafficCenterWrapperCmcc.buttonArea.parentNode.clickLogId = "cmccTrafficCharge";
                        addOnClickListener(usedTrafficCenterWrapperCmcc.buttonArea.parentNode, goToFlowChargePage, null, null);
                    } else {
                        usedTrafficPartRoot.usedTrafficClickCmccPartRoot.style.display = "block";
                    }
                    var usedTraffic = getUsedTraffic(operatorBusinessData.content);
                    var numberTraffic = Number(usedTraffic);
                    if(usedTraffic.indexOf("-") == 0 && usedTraffic.indexOf("--") != 0) {
                    	usedTraffic = usedTraffic.substring(1);
                    }
                    usedTrafficPartRoot.usedTrafficVauleDiv.innerText = usedTraffic;
                    usedTrafficPartRoot.usedTrafficUnit.innerText = getUsedTrafficUnit(operatorBusinessData.content);
                    
                    var isNeedShowRed = false;
                    if(!isNaN(numberTraffic)) {
                        if(numberTraffic < 0) {
                            isNeedShowRed = true;
                        }
                    }
                    if(isNeedShowRed) {
                        usedTrafficPartRoot.usedTrafficVauleDiv.className = "content_part_single_line_value_red";
                        usedTrafficPartRoot.usedTrafficUnit.className = "content_part_single_line_unit_red";
                        usedTrafficPartRoot.contentArea.className = "content_part_single_line_content_red";
                        usedTrafficPartRoot.contentArea.innerText = "超出";
                    } else {
                        usedTrafficPartRoot.usedTrafficVauleDiv.className = "content_part_single_line_value";
                        usedTrafficPartRoot.usedTrafficUnit.className = "content_part_single_line_unit";
                        usedTrafficPartRoot.contentArea.className = "content_part_single_line_content";
                        usedTrafficPartRoot.contentArea.innerText = "剩余";
                    }
                    //设置买流量按钮
                    usedTrafficPartRoot.flowChargeBtn.innerText = getFlowChargeBtnName(operatorBusinessData.content);
                } else {
                    if(usedTrafficPartRoot.usedTrafficClickCmccPartRoot) {
                        usedTrafficPartRoot.usedTrafficClickCmccPartRoot.style.display = "none";
                    }
                    if(!usedTrafficPartRoot.usedTrafficClickNonCmccPartRoot) {
                        var usedTrafficClickNonCmccPartRoot = document.createElement("div");
                        usedTrafficClickNonCmccPartRoot.className = "css_content_part_usedtraffic_click_noncmcc_part_div";
                        usedTrafficPartRoot.usedTrafficClickNonCmccPartRoot = usedTrafficClickNonCmccPartRoot;
                        usedTrafficPartRoot.appendChild(usedTrafficClickNonCmccPartRoot);
                        var usedTrafficCenterWrapperNonCmcc = document.createElement("div");
                        usedTrafficCenterWrapperNonCmcc.className = "css_content_part_usedtraffic_centerwrapper_noncmcc_div";
                        usedTrafficClickNonCmccPartRoot.appendChild(usedTrafficCenterWrapperNonCmcc);

                        var usedTrafficQueryImgDiv = document.createElement("img");
                        usedTrafficQueryImgDiv.className = "css_content_part_usedtraffic_part_usedtrafficqueryimg_div";
                        usedTrafficQueryImgDiv.src = ic_mainpage_flow;
                        usedTrafficCenterWrapperNonCmcc.appendChild(usedTrafficQueryImgDiv);

                        var usedTrafficQueryTextDiv = document.createElement("div");
                        usedTrafficQueryTextDiv.className = "css_content_part_usedtraffic_part_usedtrafficquerytext_div";
                        usedTrafficQueryTextDiv.innerText = "短信查流量";
                        usedTrafficCenterWrapperNonCmcc.appendChild(usedTrafficQueryTextDiv);
                        
                        usedTrafficClickNonCmccPartRoot.clickLogFocus = DATA_TRANSFER_FOCUS;
                        usedTrafficClickNonCmccPartRoot.clickLogId = "noncmccTraffic";
                        addOnClickListener(usedTrafficClickNonCmccPartRoot, smsQueryUsedTraffic, null, "#efefef");
                    } else {
                        usedTrafficPartRoot.usedTrafficClickNonCmccPartRoot.style.display = "block";
                    }
                }
            };
            usedTrafficPartRoot.refreshData(isCmcc);
            return usedTrafficPartRoot;
        }
        
        //创建一行（话费、流量、通话时长）的视图
        function createSingleLinePart() {
        	//根布局
        	var lineRoot = document.createElement("div");
        	lineRoot.className = "content_part_single_line_root";
        	
        	//标题
        	var titleAreaWrapper = document.createElement("div");
        	titleAreaWrapper.className = "content_part_single_line_title_wrapper";
        	
        	var titleIc = document.createElement("img");
        	titleIc.className = "content_part_single_line_ic";
        	titleAreaWrapper.appendChild(titleIc);
        	
        	lineRoot.titleIc = titleIc;
        	
        	var titleArea = document.createElement("div");
        	titleArea.className = "content_part_single_line_title";
        	titleAreaWrapper.appendChild(titleArea);
        	lineRoot.appendChild(titleAreaWrapper);
        	lineRoot.titleArea = titleArea;
        	
        	//剩余文案
      		var contentAreaWrapper = document.createElement("div");
        	contentAreaWrapper.className = "content_part_single_line_content_wrapper";
        	var contentArea = document.createElement("div");
        	contentArea.className = "content_part_single_line_content";
        	contentAreaWrapper.appendChild(contentArea);
        	lineRoot.appendChild(contentAreaWrapper);
        	lineRoot.contentArea = contentArea;
        	
        	//值
      		var valueAreaWrapper = document.createElement("div");
        	valueAreaWrapper.className = "content_part_single_line_value_wrapper";
        	var valueArea = document.createElement("div");
        	valueArea.className = "content_part_single_line_value";
        	valueAreaWrapper.appendChild(valueArea);
        	lineRoot.appendChild(valueAreaWrapper);
        	lineRoot.valueArea = valueArea;
        	
        	//单位
      		var unitAreaWrapper = document.createElement("div");
        	unitAreaWrapper.className = "content_part_single_line_unit_wrapper";
        	var unitArea = document.createElement("div");
        	unitArea.className = "content_part_single_line_unit";
        	unitAreaWrapper.appendChild(unitArea);
        	lineRoot.appendChild(unitAreaWrapper);
        	lineRoot.unitArea = unitArea;
        	
        	//按钮
        	var buttonAreaWrapper = document.createElement("div");
        	buttonAreaWrapper.className = "content_part_single_line_button_wrapper";
        	var buttonArea = document.createElement("div");
        	buttonArea.className = "content_part_single_line_button";
        	buttonAreaWrapper.appendChild(buttonArea);
        	//lineRoot.appendChild(buttonAreaWrapper);
        	lineRoot.buttonArea = buttonArea;
        	
        	return lineRoot;
        }
        
        function createFootPart(isCmcc) {
            var footPartRoot = document.createElement("div");
            footPartRoot.className = "css_card_bottom_btn";
            
            //footPartRoot.clickLogFocus = TELEPHONE_FEE_FOCUS;
            footPartRoot.clickLogId = "moreBtn";
            addOnClickListener(footPartRoot, goToDetailPage, null, "#efefef");
            footPartRoot.refreshData = function() {
                footPartRoot.innerText = getDetailName(operatorBusinessData.content);
	            if(!isCmcc) {
	            	footPartRoot.style.display = "none";
	            }
            };
            footPartRoot.refreshData();
            return footPartRoot;
        }

        function goToDetailPage() {
            exec("LogComponents", "addCmccLog", ["LX_100061"]);
            var detailUrl = getDetailUrl(operatorBusinessData.content);
            console.log("HFLL_ goToDetailPage: " + detailUrl);
            exec("UIComponents", "openBrowser", ["", detailUrl]);
        }
        
        function goToPhoneCreditDetailPage() {
            var pcurl = getPhoneCreditUrl(operatorBusinessData.content);
            console.log("HFLL_ goToPhoneCreditDetailPage: " + pcurl);
            exec("UIComponents", "openBrowser", ["", pcurl]);
        }
        
        function goToUsedTrafficDetailPage() {
            var uturl = getUsedTrafficUrl(operatorBusinessData.content);
            console.log("HFLL_ goToUsedTrafficDetailPage: " + uturl);
            exec("UIComponents", "openBrowser", ["", uturl]);
        }
        
        function goToFeeChargePage() {
        	exec("LogComponents", "addCmccLog", ["LX_100058"]);
            exec("UIComponents", "openBrowser", ["", getFeeChargeBtnUrl(operatorBusinessData.content)]);
        }
        
        function goToFlowChargePage() {
        	exec("LogComponents", "addCmccLog", ["LX_100059"]);
            exec("UIComponents", "openBrowser", ["", getFlowChargeBtnUrl(operatorBusinessData.content)]);
        }
        
        function goToSpeakTimePage() {
        	exec("LogComponents", "addCmccLog", ["LX_100060"]);
            exec("UIComponents", "openBrowser", ["", getSpeakTimePageUrl(operatorBusinessData.content)]);        	
        }

        function smsQueryPhoneCredit() {
            console.log("HFLL_ smsQueryPhoneCredit()");
            exec("lxOvsExtComponents", "queryBySms", ["queryTelFee"]);
        }

        function smsQueryUsedTraffic() {
            console.log("HFLL_ smsQueryUsedTraffic()");
            exec("lxOvsExtComponents", "queryBySms", ["queryDataTrans"]);
        }

        function getPhoneCredit(content) {
            try{
                return content.bill.balance;
            }catch(e) {
                return null;
            }
        }
        
        function getSpeakTime(content) {
			try {
				return content.speakTime.left;
			} catch(e) {
				return null;
			}
        }
        
        function getFeeChargeBtnName(content) {
        	var name= null;
            try{
                name = content.bill.button.name;
                if(isEmptyStr(name)) {
                	name = "充话费";
                }
            }catch(e) {
                name = "充话费";
            }
            return name;
        }
        
        function getFlowChargeBtnName(content) {
        	var name= null;
            try{
                name = content.gprs.button.name;
                if(isEmptyStr(name)) {
                	name = "买流量";
                }
            }catch(e) {
                name = "买流量";
            }
            return name;
        }
        
        function getFeeChargeBtnUrl(content) {
            var url = null;
            try{
                url = content.bill.button.url;
                if(isEmptyStr(url)) {
                    url = getDetailUrl(content);
                }
            }catch(e) {
                url = getDetailUrl(content);
            }
            return url;
        }
        
        function getFlowChargeBtnUrl(content) {
            var url = null;
            try{
                url = content.gprs.button.url;
                if(isEmptyStr(url)) {
                    url = getDetailUrl(content);
                }
            }catch(e) {
                url = getDetailUrl(content);
            }
            return url;
        }
        
        function getSpeakTimePageUrl(content) {
            var url = null;
            try{
                url = content.speakTime.url;
                if(isEmptyStr(url)) {
                    url = getDetailUrl(content);
                }
            }catch(e) {
                url = getDetailUrl(content);
            }
            return url;
        }
        
        function getPhoneCreditUrl(content) {
            var url = null;
            try{
                url = content.bill.url;
                if(isEmptyStr(url)) {
                    url = getDetailUrl(content);
                }
            }catch(e) {
                url = getDetailUrl(content);
            }
            return url;
        }

        function getPhoneCreditUnit(content) {
            try{
                return content.bill.unit;
            }catch(e) {
                return null;
            }
        }

        function getUsedTraffic(content) {
            try{
                return content.gprs.left;
            }catch(e) {
                return null;
            }
        }
        
        function getUsedTrafficUrl(content) {
            var url = null;
            try{
                url = content.gprs.url;
                if(isEmptyStr(url)) {
                    url = getDetailUrl(content);
                }
            }catch(e) {
                url = getDetailUrl(content);
            }
            return url;
        }

        function getUsedTrafficUnit(content) {
            try{
                return content.gprs.unit;
            }catch(e) {
                return null;
            }
        }

        function getDetailName(content) {
            try{
                return content.bottomButton[0].name;
            }catch(e) {
                console.log("HFLL_ getDetailName error :" + e);
                return null;
            }
        }

        function getDetailUrl(content) {
            try{
                return content.bottomButton[0].url;
            }catch(e) {
                console.log("HFLL_ getDetailUrl error: " + e);
                return null;
            }
        }

        function getOperator(content) {
            try {
                return content.operator;
            }catch (e) {
                return null;
            }
        }

        console.log("HFLL_ createOperatorMainPage() ");
        var operatorContentPart = document.createElement("div");

        operatorContentPart.refreshData = function () {
            var isCmccFlag = (getOperator(operatorBusinessData.content) == "cmcc");
            //显示刷新按钮，是否显示更新时间由是否移动结果判定
            cardContainInner.headPart.refreshData(isCmccFlag, isCmccFlag);

            if (!operatorContentPart.contentPartDiv) {
                var contentPartDiv = createContentPart(isCmccFlag);
                operatorContentPart.contentPartDiv = contentPartDiv;
                operatorContentPart.appendChild(contentPartDiv);
            } else {
                operatorContentPart.contentPartDiv.refreshData(isCmccFlag);
            }

            if (!operatorContentPart.footPartDiv) {
                var footPartDiv = createFootPart(isCmccFlag);
                operatorContentPart.footPartDiv = footPartDiv;
                operatorContentPart.appendChild(footPartDiv);
            } else {
                operatorContentPart.footPartDiv.refreshData(isCmccFlag);
            }
        };

        operatorContentPart.refreshData();
        return operatorContentPart;
    }

    function createOperatorBusinessWaitingView() {
        console.log("HFLL_ createOperatorBusinessWaitingView: ");

        var contentDiv = document.createElement("div");
        contentDiv.className = "css_waiting_view_content";

        var waitingIcon = document.createElement("img");
        waitingIcon.className = "css_waiting_view_icon";
        waitingIcon.src = frame_loading_img;
        startLoading(waitingIcon);
        contentDiv.appendChild(waitingIcon);

        var waitingTip = document.createElement("div");
        waitingTip.className = "css_waiting_view_text";
        waitingTip.innerText = "正在加载";
        contentDiv.appendChild(waitingTip);

        contentDiv.refreshData = function() {
            //更新和刷新都不需要显示
            cardContainInner.headPart.refreshData(false, false);
        };

        contentDiv.refreshData();

        return contentDiv;
    }

    function createOperatorBusinessErrorView(errorCodeParam) {
        console.log("HFLL_ createOperatorBusinessErrorView: ");
        currentErrorCode = errorCodeParam;

        var contentDiv = document.createElement("div");
        //TODO 客户端版本兼容，低版本没有相关API，不展示验证码条目，高度不同，需要适配
        if(CMCC_CLIENT_APP_VERSION && CMCC_CLIENT_APP_VERSION > VERIFY_MIN_VERSION) {
	       contentDiv.className = "css_error_view_content";
        } else {
        	contentDiv.className = "css_error_view_content_low";
        }
        var errorTip = document.createElement("div");
        //TODO 客户端版本兼容，低版本没有相关API，不展示验证码条目，高度不同，需要适配
        if(CMCC_CLIENT_APP_VERSION && CMCC_CLIENT_APP_VERSION > VERIFY_MIN_VERSION) {
	        errorTip.className = "css_error_view_text";
        } else {
        	errorTip.className = "css_error_view_text_low"; 
        }
        contentDiv.errorTip = errorTip;
        contentDiv.appendChild(errorTip);
        
        errorTip.clickLogFocus = TELEPHONE_FEE_FOCUS;
        errorTip.clickLogId = "errorTip";
        addOnClickListener(errorTip, userErrorRefresh, errorCodeParam, "#efefef");

        contentDiv.refreshData = function(errorCodeParam) {
            currentErrorCode = errorCodeParam;
            //更新和刷新都不需要显示
            cardContainInner.headPart.refreshData(false, false);
            contentDiv.errorTip.innerText = getTipByErrorCode(errorCodeParam);
            contentDiv.refreshErrorView(errorCodeParam);

        };
        
        var unauthViewDiv = createUnauthView(errorCodeParam);
        contentDiv.unauthViewDiv = unauthViewDiv;
		contentDiv.appendChild(unauthViewDiv);

		contentDiv.refreshErrorView = function(errorCodeParam) {
			if (TOKEN_INEFFCTIVE_ERROR == errorCodeParam
					|| COMMON_NO_TOKEN_ERROR == errorCodeParam) {
				console.log("HFLL_ createOperatorBusinessErrorView: none ");
				contentDiv.errorTip.style.display = "none";
				contentDiv.unauthViewDiv.style.display = "block";
			} else {
				console.log("HFLL_ createOperatorBusinessErrorView: block");
				contentDiv.errorTip.style.display = "block";
				contentDiv.unauthViewDiv.style.display = "none";
			}

		};

		contentDiv.refreshErrorView(errorCodeParam);
		
		contentDiv.refreshData(errorCodeParam);
		return contentDiv;
    }
    
    function createUnauthView(errorCodeParam) {
		
	   	var unauthViewDiv = document.createElement("div");
		//TODO 客户端版本兼容，低版本没有相关API，不展示验证码条目，高度不同，需要适配
	   	if(CMCC_CLIENT_APP_VERSION && CMCC_CLIENT_APP_VERSION > VERIFY_MIN_VERSION) {
			unauthViewDiv.className = "css_error_unauth_view_content";
	   	} else {
			unauthViewDiv.className = "css_error_unauth_view_content_low";
	   	}
		// 话费账单
		var callFeesDiv = document.createElement("div");
		callFeesDiv.className = "css_error_callfee_view_content";
		unauthViewDiv.appendChild(callFeesDiv);
		
		var callFeesLeft = document.createElement("div");
		callFeesLeft.className = "css_call_flow_item_left";
		
		var callFeesIc = document.createElement("img");
		callFeesIc.className = "css_call_flow_item_ic";
		callFeesIc.src = ic_mainpage_calls;
		
		var callFeesTip = document.createElement("div");
		callFeesTip.className = "css_error_callfee_flow_view_tip";
		//callFeesDiv.appendChild(callFeesTip);
		callFeesTip.innerText = "话费";
		
		callFeesLeft.appendChild(callFeesIc);
		callFeesLeft.appendChild(callFeesTip);
		
		callFeesDiv.appendChild(callFeesLeft);

		var callFeesRight = document.createElement("div");
		callFeesRight.className = "css_call_flow_item_right";
		
		var callRemainTipOne = document.createElement("div");
		callRemainTipOne.className = "css_error_callfee_flow_remain_left_tip";
		//callFeesDiv.appendChild(callRemainTipOne);
		callRemainTipOne.innerText = "剩余";
		
		var unknown_call_value = document.createElement("div");
		unknown_call_value.className = "css_error_callfee_flow_unkown_tip";
		unknown_call_value.innerText = "----";
		
		var callRemainTipImage = document.createElement("img");
		callRemainTipImage.className = "css_error_callfee_flow_img_div";
		callRemainTipImage.src = ic_callflow_pic;
		//callFeesDiv.appendChild(callRemainTipImage);
		
	   	var callRemainTipTwo = document.createElement("div");
		callRemainTipTwo.className = "css_error_callfee_flow_remain_right_tip";
		//callFeesDiv.appendChild(callRemainTipTwo);
		callRemainTipTwo.innerText = "元";
		
		callFeesRight.appendChild(callRemainTipOne);
		callFeesRight.appendChild(unknown_call_value);
		callFeesRight.appendChild(callRemainTipTwo);
		
		callFeesDiv.appendChild(callFeesRight);

		var callExposeTip = document.createElement("div");
		callExposeTip.className = "css_error_callfee_flow_expose_tip";
		//callFeesDiv.appendChild(callExposeTip);
		callExposeTip.innerText = "点击揭秘";
		
		callFeesDiv.clickLogFocus = TELEPHONE_FEE_FOCUS;
        callFeesDiv.clickLogId = "unauth_tel_fee";
		
	   	addOnClickListener(callFeesDiv, userErrorRefresh, errorCodeParam ,  "#efefef");

		var spaceDiv = document.createElement("div");
		spaceDiv.className = "css_error_callfee_flow_space_div";
		unauthViewDiv.appendChild(spaceDiv);
		
		// 流量
		var flowDiv = document.createElement("div");
		flowDiv.className = "css_error_flow_view_content";
		unauthViewDiv.appendChild(flowDiv);
		
		var flowLeft = document.createElement("div");
		flowLeft.className = "css_call_flow_item_left";
		
		var flowIc = document.createElement("img");
		flowIc.className = "css_call_flow_item_ic";
		flowIc.src = ic_mainpage_flow;
		
		var flowTip = document.createElement("div");
		flowTip.className = "css_error_callfee_flow_view_tip";
		//flowDiv.appendChild(flowTip);
		flowTip.innerText = "流量";
		
		flowLeft.appendChild(flowIc);
		flowLeft.appendChild(flowTip);
		
		flowDiv.appendChild(flowLeft);
		
		var flowRight = document.createElement("div");
		flowRight.className = "css_call_flow_item_right";

		var flowRemainTipOne = document.createElement("div");
		flowRemainTipOne.className = "css_error_callfee_flow_remain_left_tip";
		//flowDiv.appendChild(flowRemainTipOne);
		flowRemainTipOne.innerText = "剩余";

		var callRemainTipImageTwo = document.createElement("img");
		callRemainTipImageTwo.className = "css_error_callfee_flow_img_div";
		callRemainTipImageTwo.src = ic_callflow_pic;
		//flowDiv.appendChild(callRemainTipImageTwo);
		
		var unknown_flow_value = document.createElement("div");
		unknown_flow_value.className = "css_error_callfee_flow_unkown_tip";
		unknown_flow_value.innerText = "----";
		
	    var flowRemainTipTwo = document.createElement("div");
		flowRemainTipTwo.className = "css_error_callfee_flow_remain_right_tip";
		//flowDiv.appendChild(flowRemainTipOne);
		flowRemainTipTwo.innerText = "M";
		
		flowRight.appendChild(flowRemainTipOne);
		flowRight.appendChild(unknown_flow_value);
		flowRight.appendChild(flowRemainTipTwo);
		
		flowDiv.appendChild(flowRight);
		
		var flowExposeTip = document.createElement("div");
		flowExposeTip.className = "css_error_callfee_flow_expose_tip";
		//flowDiv.appendChild(flowExposeTip);
		flowExposeTip.innerText = "点击揭秘";
		
		flowDiv.clickLogFocus = DATA_TRANSFER_FOCUS;
        flowDiv.clickLogId = "unauth_tel_flow";

		addOnClickListener(flowDiv, userErrorRefresh, errorCodeParam ,  "#efefef");

        //验证码鉴权提示条目
        var spaceDiv1 = document.createElement("div");
        spaceDiv1.className = "css_error_callfee_flow_space_div";
        unauthViewDiv.appendChild(spaceDiv1);

        var verifyBox = document.createElement("div");
        verifyBox.className = "css_error_verify_box";
        var verifyDiv = document.createElement("div");
        verifyDiv.className = "css_error_verify_div";
        var verifyTipDiv = document.createElement("div");
        verifyTipDiv.className = "css_error_verify_div_tip";
        verifyTipDiv.innerText = "输入号码，免费查询话费流量";
        var verifyBtnDiv = document.createElement("div");
        verifyBtnDiv.className = "css_error_verify_div_btn";
        verifyBtnDiv.innerText = "立即查询";

        verifyDiv.appendChild(verifyTipDiv);
        verifyDiv.appendChild(verifyBtnDiv);
        verifyBox.appendChild(verifyDiv);
        
        verifyBox.clickLogId = "unauth_tel_verify";
        //TODO 客户端版本兼容，低版本没有相关API，不展示
		if(CMCC_CLIENT_APP_VERSION && CMCC_CLIENT_APP_VERSION > VERIFY_MIN_VERSION) { 
	        unauthViewDiv.appendChild(verifyBox);
	
	        addOnClickListener(verifyBox, userErrorRefresh, errorCodeParam ,  "#efefef");
		}
		
		return unauthViewDiv;

	}

    function getTipByErrorCode(errorCode){
        var tip = "加载失败，点击重试";
        if(TOKEN_INEFFCTIVE_ERROR == errorCode || COMMON_NO_TOKEN_ERROR == errorCode) {
            tip = "该手机号未激活，点击激活";
        } else if(WAIT_FOR_AUTH_ERROR == errorCode) {
            tip = "手机号激活中，请稍候...";
        }
        return tip;
    }

    function userErrorRefresh() {
        console.log("HFLL_ userErrorRefresh() errorCode:" + currentErrorCode);
        if(currentErrorCode == WAIT_FOR_AUTH_ERROR) {
            return;
        }
        sendDataRefreshOrAuth("error_page");
    }

    function handleOperatorBusiness() {
        isCssLoaded = true;
        cardContainInner.innerHTML = "";

        //创建共同的头部部分,更新时间和刷新按钮先不创建
        createHeadPart();

        //内容部分占位div
        var contentPartContainer = document.createElement("div");
        cardContainInner.contentPartContainer = contentPartContainer;
        cardContainInner.appendChild(contentPartContainer);

        //展示缓存数据
        if (isOpBusinessDataLegal(operatorBusinessData)) {
            showOperatorBusinessPage();
        } else {
            showRefreshingPage();
        }
        sendDataRequest(UPDATE_TRIGGER_FRAME_LOAD);
        var card_bottom_shadow = document.createElement("div");
        card_bottom_shadow.className = "css_card_bottom_shadow";
        cardContainInner.appendChild(card_bottom_shadow);
        isCardContentCreated = true;
    }

    return createCardFrame;
});