define(function(){
    var cardContainer = null;
    var lifeArea = null;
    var lifeCardData = null;
    var lifeXcssParsed = false;
    
    var zdOffDom = null;
    var speechCaseDom = null;
    
    function create(lifeData){
        console.log("create life card begins: " + lifeData.id);
        if (!lifeData) {
            console.log("lifeData is null");
            return;
        }
        lifeCardData = lifeData;
        console.log("lifeCardData.id: " + lifeCardData.id);
        console.log("lifeCardData.version: " + lifeCardData.version);
        
        cardContainer = document.createElement("div");
        cardContainer.id = lifeCardData.id;
        lifeArea = document.createElement("div");
        lifeArea.className = "css_card";
        
        // 卡片管理更新显示状态
        cardContainer.updateState = function(state){
            if (state) {
                if (lifeXcssParsed) {
                    cardContainer.style.display = "block";
                }
                else {
                    lifeXcssParsed = true;
                    xcssParser.parseStyleFile("./life/business.x.css", onResourceLoadFinish);
                }
                lifeCardData.show = true;
            }
            else {
                cardContainer.style.display = "none";
                lifeCardData.show = false;
            }
            
            // 缓存
            cacheMgr.setCache(lifeCardData.id, JSON.stringify(lifeCardData));
        };
        
        // 读取缓存
        var lifeCacheData = null;
        var lifeCacheString = cacheMgr.getCache(lifeData.id);
        if (lifeCacheString) {
            if (typeof lifeCacheString == "string") {
                try {
                    lifeCacheData = JSON.parse(lifeCacheString);
                } 
                catch (e) {
                    console.log("JSON parse exception");
                }
            }
        }
        if (lifeCacheData) {
            lifeCardData.show = lifeCacheData.show;
            if (lifeCacheData.version == lifeData.version) {
                // 保证卡片的caseList使用默认数据
                lifeCardData.caseList = lifeData.caseList;
                lifeCardData.caseRedDot = lifeCacheData.caseRedDot;
            }
            cacheMgr.setCache(lifeCardData.id, JSON.stringify(lifeCardData));
        }
        else {
            cacheMgr.setCache(lifeCardData.id, JSON.stringify(lifeCardData));
        }
        
        if (lifeCardData.show) {
            lifeXcssParsed = true;
            xcssParser.parseStyleFile("./life/business.x.css", onResourceLoadFinish);
        }
        
        listener.callBack(lifeCardData.id, CARD_CONTENT_NO_REQUEST);
        
        cardContainer.date_type = "card";
        cardContainer.initShowState = lifeCardData.show;
        
        return cardContainer;
    }
    
    
    
    function operateCallBack(callBackId){
        switch (callBackId) {
            case 0: // 取消
                zdOffDom.style.display = "none";
                lifeArea.style.display = "block";
                break;
            case 1: // 置顶
                zdOffDom.style.display = "none";
                lifeArea.style.display = "block";
                stickTopCardByDom(cardContainer);
                break;
            case 2: // 点击关闭
                // 显示关闭确认弹框，暂时未实现
                //showCloseConfirmDialogById(cardContainer.id);
                break;
                
            default:
                break;
        }
    }
    function speechCaseCallBack(){
        if (zdOffDom) {
            zdOffDom.style.display = "none";
        }
        if (speechCaseDom) {
            speechCaseDom.style.display = "none";
        }
        lifeArea.style.display = "block";
    }
    function titleResponseListener(responseId){
        switch (responseId) {
            case 0: // 点击说法示例区域
                if(lifeCardData && lifeCardData.caseRedDot) {
                    lifeCardData.caseRedDot = false;
                    cacheMgr.setCache(lifeCardData.id, JSON.stringify(lifeCardData));
                }
                if (zdOffDom) {
                    zdOffDom.style.display = "none";
                }
                
                lifeArea.style.display = "none";
                if (speechCaseDom) {
                    speechCaseDom.style.display = "block";
                }
                else {
                    speechCaseDom = createSpeechCaseView(lifeCardData.id, lifeCardData.name, lifeCardData.caseList);
                    // 判断一下是否为空
                    speechCaseDom.setCancelListener(speechCaseCallBack);
                    cardContainer.appendChild(speechCaseDom);
                }
                break;
            case 1: // 点击置顶箭头按钮
                if (speechCaseDom) {
                    speechCaseDom.style.display = "none";
                }
                lifeArea.style.display = "none";
                
                if (zdOffDom) {
                    zdOffDom.style.display = "block";
                }
                else {
                    zdOffDom = createOperationView(lifeCardData.id, lifeCardData.name, cardContainer.id);
                    //判断一下是否为空
                    zdOffDom.setOpListener(operateCallBack);
                    cardContainer.appendChild(zdOffDom);
                }
                break;
            case 2: // 刷新，暂时没有实现
                break;
            default:
                break;
        }
    }
    function showContentPage(){
        if (zdOffDom) {
            zdOffDom.style.display = "none";
        }
        if (speechCaseDom) {
            speechCaseDom.style.display = "none";
        }
        lifeArea.style.display = "block";
    }
    
    
    function onResourceLoadFinish(){
        console.log("onResourceLoadFinish begins");
        createLifeArea();
    }
    
    function createLifeArea(){
        console.log("createLifeArea begins");
        
        //var titleDiv = createTitleDiv();
        var titleDiv = createCardMainTitle(lifeCardData.id, lifeCardData.name, lifeCardData.caseList[0], titleResponseListener, lifeCardData.caseRedDot);
        
        var contentDivOuter = document.createElement("div");
        contentDivOuter.className = 'life_content_div_outer';
        contentDivOuter.appendChild(createContentDiv());
        
        //底部添加阴影
        var card_bottom_shadow = document.createElement("div");
        card_bottom_shadow.className = "css_card_bottom_shadow";
        
        lifeArea.appendChild(titleDiv);
        lifeArea.appendChild(contentDivOuter);
        lifeArea.appendChild(createFooter());
        lifeArea.appendChild(card_bottom_shadow);
        cardContainer.appendChild(lifeArea);
        cardContainer.showContentPage = showContentPage;
    }
    
    function createTitleDiv(){
        console.log("createTitleDiv begins");
        var titleDiv = document.createElement("div");
        titleDiv.className = "css_card_title_bar";
        var label = document.createElement("label");
        label.className = "css_card_title_text";
        label.innerText = lifeCardData.name;
        titleDiv.appendChild(label);
        return titleDiv;
    }
    
    // 创建底部按钮
    function createFooter(){
        console.log("createFooter");
        
        var footer = document.createElement("div");
        footer.className = "css_card_bottom_btn";
        footer.opKey = "moreBtn";
        
        if (lifeCardData.content.bottomButton && lifeCardData.content.bottomButton.length > 0) {
            footer.innerHTML = lifeCardData.content.bottomButton[0].name;
            footer.url = lifeCardData.content.bottomButton[0].url;
        }
        else {
            footer.innerHTML = "查看更多";
            footer.url = "http://stat.hao.uc.cn/stat_site.php?nid=34561&fcid=1891&cid=483&page=navi_online_index&uuid=71d4da44-a81f-d412-8053-ad257623808e";
        }
        
        var targetItem = null;
        var cardBottomMove = false;
        footer.addEventListener("touchstart", function(){
            console.log("footer touchstart");
            event.stopPropagation();
            moveOverCheck.start(event);
            cardBottomMove = false;
            targetItem = event.target;
            if (targetItem) {
                targetItem.style.backgroundColor = "#efefef";
            }
        }, false);
        footer.addEventListener("touchmove", function(){
            console.log("footer touchmove");
            event.stopPropagation();
            if (moveOverCheck.check(event)) {
                cardBottomMove = true;
            }
            targetItem.style.backgroundColor = "";
        }, false);
        footer.addEventListener("touchend", function(){
            console.log("footer touchend");
            event.stopPropagation();
            
            if (cardBottomMove == false) {
                targetItem.style.backgroundColor = "";
                if (targetItem) {
                    // 点击查看更多按钮
                    if (footer.url) {
                        exec('UIComponents', "openBrowser", ["", footer.url]);
                    }
                    exec("WidgetMMPContainerComponents", "appenCardCpaLog", ["website"]);
                    exec("WidgetMMPContainerComponents", "appenCardOpLog", [cardOpCode.life, footer.opKey]);
                    
                }
            }
            targetItem = null;
        }, false);
        
        return footer;
    }
    
    function createContentDiv(){
        console.log("createContentDiv begins");
        if (!lifeCardData.content.service) {
            return null;
        }
        var lifeContentFragments = createContentFragments(lifeCardData.content.service);
        
        var touchTarget = null;
        lifeArea.addEventListener("touchstart", function(){
            event.stopPropagation();
            // 避免同时出现按下两个按钮不回退的情况
            if (touchTarget) {
                touchTarget.backE.style.backgroundColor = "";
            }
            touchTarget = getParentOfClass("life_single_item", event.target);
            if (touchTarget) {
                touchTarget.backE.style.backgroundColor = "#efefef";
                moveOverCheck.start(event);
            }
        }, false);
        
        lifeArea.addEventListener("touchmove", function(){
            event.stopPropagation();
            if (touchTarget) {
                if (touchTarget.backE) {
                    touchTarget.backE.style.backgroundColor = "";
                }
                if (moveOverCheck.check(event)) {
                    touchTarget = null;
                }
            }
        }, false);
        
        lifeArea.addEventListener("touchcancel", function(){
            event.stopPropagation();
            if (touchTarget) {
                if (touchTarget.backE) {
                    touchTarget.backE.style.backgroundColor = "";
                }
                touchTarget = null;
            }
        }, false);
        
        lifeArea.addEventListener("touchend", function(){
            event.stopPropagation();
            if (touchTarget && touchTarget.backE) {
                touchTarget.backE.style.backgroundColor = "";
                exec("UIComponents", "openBrowser", ["", touchTarget.attribute.link]);
                // 日志统计
                exec("WidgetMMPContainerComponents", "appenCardCpaLog", [touchTarget.attribute.focus]);
                exec("WidgetMMPContainerComponents", "appenCardOpLog", [cardOpCode.life, touchTarget.opCodeKey]);
            }
            touchTarget = null;
        }, false);
        
        return lifeContentFragments;
    }
    
    function createContentFragments(content){
        console.log("createContentFragments begins");
        var length = content.length;
        console.log("content withLog length: " + length);
        
        var contentFragments = null;
        if (content && length && length > 0) {
            contentFragments = document.createDocumentFragment();
            var grid = [];
            for (var nCount = 0; nCount < length; nCount++) {
                grid[nCount] = createGridDiv(content[nCount]);
                grid[nCount].attribute = content[nCount];
                grid[nCount].opCodeKey = "lifeCard" + ((nCount < 9) ? "0" : "") + (nCount + 1);
                contentFragments.appendChild(grid[nCount]);
            }
        }
        return contentFragments;
    }
    
    function createGridDiv(tempData){
        console.log("createGridDiv begins");
        
        var gridDiv = document.createElement("div");
        gridDiv.className = "life_single_item";
        
        var container = document.createElement("div");
        container.className = "life_single_item_container";
        
        var logo = document.createElement("img");
        var title = document.createElement("div");
        logo.className = "life_single_item_logo";
        title.className = "life_single_item_name";
        
        logo.src = tempData.logoUrl;
        logo.onerror = function(){
            console.log("lifeCard logo load error, logo.src: " + logo.src);
        };
        title.innerHTML = tempData.name;
        
        container.appendChild(logo);
        container.appendChild(title);
        gridDiv.appendChild(container);
        
        gridDiv.backE = container;
        return gridDiv;
    }
	
	return create;
});
