var MAX_LOCAL_VIEW_NUMBER = 4;
var ic_mainpage_telephone = "file:///android_asset/local/img/ic_mainpage_telephone.png";
var ic_mainpage_schedule = "file:///android_asset/local/img/ic_mainpage_schedule.png";
var ic_mainpage_translation = "file:///android_asset/local/img/ic_mainpage_translation.png";
var ic_mainpage_plugin = "file:///android_asset/local/img/ic_mainpage_plugin.png";
var ic_mainpage_smarthome = "file:///android_asset/local/img/ic_mainpage_smarthome.png";
var ic_mainpage_hummusic = "file:///android_asset/local/img/ic_mainpage_music.png";
var ic_local_red = "file:///android_asset/local/img/ic_local_red.png";
//说法示例箭头
var ic_viewsample_arrow_down_local = "file:///android_asset/local/img/ic_viewsample_arrow_down_local.png";

var localData = [
    {
        id: "id_local_call",
        focus: "telephone",
        title: "电话短信",
        logoUrl: ic_mainpage_telephone,
        target: {
            actionType: "OPEN_LOCAL_CARD",
            title: "电话短信",
            actionParams: [
                {
                    type: "local",
                    url: "telephone"
                }
            ]
        }
    },
    {
        id: "id_local_schedule",
        focus: "schedule",
        title: "提醒",
        logoUrl: ic_mainpage_schedule,
        target: {
            actionType: "OPEN_LOCAL_CARD",
            title: "提醒",
            actionParams: [
                {
                    type: "local",
                    url: "schedule"
                }
            ]
        }
    },
    {
        id: "id_local_translation",
        focus: "translation",
        title: "翻译",
        logoUrl: ic_mainpage_translation,
        target: {
            actionType: "OPEN_LOCAL_CARD",
            title: "翻译",
            actionParams: [
                {
                    type: "local",
                    url: "translation"
                }
            ]
        }
    },
    {
        id: "id_local_plugin_manager",
        focus: "plugin_manager",
        title: "更多功能",
        logoUrl: ic_mainpage_plugin,
        target: {
            actionType: "OPEN_LOCAL_CARD",
            title: "更多功能",
            actionParams: [
                {
                    type: "local",
                    url: "plugin_manager"
                }
            ]
        }
    },
    {
        id: "id_local_smarthome",
        focus: "smarthome",
        title: "智能家居",
        logoUrl: ic_mainpage_smarthome,
        target: {
            actionType: "OPEN_LOCAL_CARD",
            title: "智能家居",
            actionParams: [
                {
                    type: "local",
                    url: "smarthome"
                }
            ]
        }
    },
    {
        id: "id_local_hummusic",
        focus: "humming",
        title: "听歌识曲",
        logoUrl: ic_mainpage_hummusic,
        target: {
            actionType: "OPEN_LOCAL_CARD",
            title: "听歌识曲",
            actionParams: [
                {
                    type: "local",
                    url: "humming"
                }
            ]
        }
    }
];
var localCardCreateFinish = false;
var localRedCache = {};

var localCardRoot = document.getElementById("nav_local");
var localCardWrapper = document.getElementById("local_card_wrapper");
var titleRoot = document.getElementById("local_title_root");
var speechCaseView = null;
/**
 * 更新小红点显示
 * @param hotDataString
 */
function updateLocalCardRedDot(hotDataString){
    if(!hotDataString){
        console.log("hotDataString is illegal");
        return;
    }
    //本地缓存没有读取完成前，不进行更新——Java的红点获取速度很快，界面还没有完全展示前，更新了缓存，然后本地卡片创建，导致总是显示红点
    if(!localCardCreateFinish){
        setTimeout(function(){
            updateLocalCardRedDot(hotDataString);
        },50);
        return;
    };

    var hotData = null;
    try{
        hotData = JSON.parse(hotDataString);
    }catch(err){
        console.log("hotDataString switch to Json error, reason is " + err);
        return;
    }
    //校验数据完整性
    if(!hotData || !hotData.focus || !hotData.id){
        return;
    }

    console.log("updateLocalCardRedDot exec: " + hotDataString);

    try{
        //更新界面
        var localE = document.getElementById("lx_local_card_" + hotData.focus);
        if(localE && localE.updateRedDot){
            localE.updateRedDot(hotData);
        }
    }catch (err) {
        console.error("update local hot fail, reason is " + err);
    }
}

function createLocalHot(hotData){
    console.log("createLocalHot() " + hotData);
    var redDot = document.createElement("img");
    redDot.className = "local_red_dot";
    redDot.src = ic_local_red;
    redDot.hotData = hotData;
    var isShow = (hotData && hotData.isShow);
    console.log("need show red dot? " + isShow);
    if(!isShow){
        redDot.style.display = "none";
    }

    return redDot;
}

/**
 *
 * @param localCardData
 * @returns {HTMLElement}
 */
function createLocalCardView(localCardData, index){
    var localArea = document.createElement("div");
    localArea.id = "lx_local_card_" + localCardData.focus;
    localArea.className = "localArea";

    var localContainer = document.createElement("div");

    var logo_area = document.createElement("div");
    logo_area.className = "local_logo_area";

    var redDot = createLocalHot(localRedCache[localCardData.focus]);
    localArea.redDot = redDot;

    var localLogo = document.createElement("img");
    localLogo.className = "local_logo";
    localLogo.src = localCardData.logoUrl;

    logo_area.appendChild(localLogo);
    logo_area.appendChild(redDot);

    var localTitle = document.createElement("div");
    localTitle.className = "local_title";
    localTitle.innerHTML = localCardData.title;

    localContainer.appendChild(logo_area);
    localContainer.appendChild(localTitle);

    localArea.appendChild(localContainer);

    localArea.target = localCardData.target;
    localArea.targetId = localCardData.id;

    if(null == index) {
        index = "-1";
    }
    localArea.position = "x5y" + index;

    localArea.targetClick = function(){
        console.log("local view clicked");
        if(redDot.hotData) {
            redDot.hotData.isShow = false;
        }
        localArea.updateRedDot(redDot.hotData);
    };

    /*
     *本地视图触摸触发的点击事件的处理
     */
    localArea.onLocalAreaClick = function(){
        //localArea.target.targetId = localArea.targetId;
        //var argStr = JSON.stringify(localArea.target);

        var targetData = localCardData.target;
        targetData.targetId = localCardData.id;
        targetData.targetFocus = localCardData.focus;
        targetData.position = localArea.position;
        var scriptId = "";
        try {
            scriptId = localArea.redDot.hotData.id;
        }catch (e) {
            console.log("get scriptId failed: " + e);
        }
        localArea.target.actionParams[0].scriptId = scriptId;
        var argStr = JSON.stringify(localArea.target);

        exec("WidgetMMPContainerComponents" , "clickLocalCard" , [argStr]);
        localArea.targetClick();
    };

    localArea.updateRedDot = function(hotData){
        console.log("updateRedDot() " + hotData);
        redDot.hotData = hotData;
        if(redDot.hotData && redDot.hotData.isShow) {
            redDot.style.display = "block";
        } else {
            redDot.style.display = "none";
        }
    };

    return localArea;
}

function initRedDotData() {
    var localRedCacheResult = exec("WidgetMMPContainerComponents", "getCachedRedDot", []);
    localRedCache = getResultMessage(localRedCacheResult);
    console.log("localRedCacheStr: " + JSON.stringify(localRedCache));
}

function createLocalView(){
    initRedDotData();
    //创建可左右滑动的视图
    var localDataSwipeDivArray = new Array();
    var localDataSwipeIndex = -1;
    if(localData && localData.length && localData.length > 0){
        var localDom = [];

        for(var a1L=0; a1L < localData.length; a1L++){
            if(0 == a1L% MAX_LOCAL_VIEW_NUMBER) {
                localDataSwipeDivArray[++localDataSwipeIndex] = document.createElement("div");
            }
            localDom[a1L] = createLocalCardView(localData[a1L], a1L+1);
            localDataSwipeDivArray[localDataSwipeIndex].appendChild(localDom[a1L]);
        }
    }

    //创建底部显示滑动状态的状态栏
    var bottomBar = document.createElement("div");
    bottomBar.className = "loc_swipe-barCon";

    var dotDiv = document.createElement("div");
    dotDiv.className = "loc_swipe-dotCon";

    for (var i = 0; i < localDataSwipeDivArray.length; i ++) {
        var dot = document.createElement("div");
        if (i === 0) {
            dot.className = 'swipe-dot';
        } else {
            dot.className = "swipe-dot_not_active";
        }
        dotDiv.appendChild(dot);
    }

    bottomBar.appendChild(dotDiv);


    /**
     * 本地卡片的触摸点击事件的回调
     * @param e
     */
    function clickPage(e) {

        var navTarget = getParentOfClass("localArea", event.target);
        if(navTarget && navTarget.onLocalAreaClick) {
            navTarget.onLocalAreaClick();
        }

    }

    function swipeCallback(CurInfo) {
        var currentIndex = CurInfo.currentIndex;
        var dotArray = dotDiv.childNodes;
        for (var i = 0 ; i < dotArray.length; i ++) {
            var dot = dotArray[i];
            if (i == currentIndex) {
                dot.className = "swipe-dot";
            } else {
                dot.className = "swipe-dot_not_active";
            }
        }
    }

    var obj = {
        "parWin" : BASE.getEle("#nav_local_swipe"),
        "id" : "localBannerSwipe",
        "viewAry" : localDataSwipeDivArray,
        "bottomBar" : bottomBar,
        "swipe" : true, //Boolean, can swipe
        "autoRun" : false, //Boolean, can auto run
        "autoRunTime" : 5000, //Int, auto run time, unit ms
        "isNeedAnimation" : false, // Boolean, whether need animation when swipe
        "isNeedBar" : true, //Boolean, whether need the bottom bar
        "swipeCallback" : swipeCallback,
        "clickCallback": clickPage //Function, call the function when click the view
    };
    var BS = new BannerSwipe(obj);


    var navTarget = null;
    if ('ontouchstart' in window) {
        //如果是触摸触发的点击事件则通过回调localArea.onLocalAreaClick执行
    } else {
        document.getElementById('nav_local_swipe').addEventListener("click",function(){
            //event.stopPropagation();
            navTarget = getParentOfClass("localArea", event.target);
            if(navTarget && navTarget.target){
                var scriptId = "";
                try {
                    scriptId = navTarget.redDot.hotData.id;
                }catch (e) {
                    console.log("get scriptId failed: " + e);
                }
                navTarget.target.actionParams[0].scriptId = scriptId;
                var argStr = JSON.stringify(navTarget.target);
                exec("WidgetMMPContainerComponents" , "clickLocalCard" , [argStr]);

                if(navTarget){
                    navTarget.targetClick();
                }
            }
            navTarget = null;
        },false);
    }
    localCardCreateFinish = true;
}
function speechCaseCallBack(){
    if(speechCaseView) {
        speechCaseView.style.display = "none";
    }
    localCardWrapper.style.display = "block";
}
function showContentPage() {
    if (speechCaseView) {
        speechCaseView.style.display = "none";
    }
    localCardWrapper.style.display = "block";
}
function titleResponseListener(responseId){
    switch(responseId) {
        case 0://点击说法示例区域
            exec("WidgetMMPContainerComponents", "appenCardOpLog", ["FT69107", "speechCase"]);
            exec("LogComponents", "addCmccLog", ["LX_100055"]);
            localCardWrapper.style.display = "none";
            if (speechCaseView) {
                speechCaseView.style.display = "block";
            } else {
                speechCaseView = createSpeechCaseView("card_local", "常用功能", ['“打电话给老爸”','“把张三的号码发给李四”','“每天8点提醒我起床”']);
                //判断一下是否为空
                speechCaseView.setCancelListener(speechCaseCallBack);
                localCardRoot.appendChild(speechCaseView);
            }
            break;
        case 1://点击置顶箭头按钮
           // do nothing
            break;
        case 2://刷新，暂时没有实现
            break;
        default:
            break;
    }
}

function createCardMainTitleLocal(id, titleText, caseText, callBack, showParam){
    if(!id || !titleText || !caseText) {
        return null;
    }
    var mainTitle = document.createElement("div");
    mainTitle.className = "local_card_main_top_bar";

    var titleLeft = document.createElement("div");
    titleLeft.className = "local_card_main_top_bar_left";

    var caseTitle = document.createElement("div");
    caseTitle.className = "local_card_main_top_bar_left_tile";
    caseTitle.innerHTML = titleText;
    var caseContent = document.createElement("div");
    caseContent.className = "local_card_main_top_bar_left_case";
    caseContent.innerHTML = caseText;
    var caseArrow = document.createElement("img");
    caseArrow.className = "local_card_main_top_bar_left_case_arrow";
    caseArrow.src = ic_viewsample_arrow_down_local;

    titleLeft.appendChild(caseTitle);
    titleLeft.appendChild(caseContent);
    titleLeft.appendChild(caseArrow);

    var titleRight = document.createElement("div");
    titleRight.className = "local_card_main_top_bar_right";
    var arrow = document.createElement("img");
    arrow.src = ic_mainpage_card_menu;
    arrow.className = "local_card_main_top_bar_right_arrow";
    titleRight.appendChild(arrow);

    mainTitle.appendChild(titleLeft);
    if(false !== showParam) {
        mainTitle.appendChild(titleRight);
    }

    var titleOpListener = callBack;
    mainTitle.setMainTitleOpListener = function(listener){
        if(!listener){
            console.warn("WebHomePage card " + id + " setMainTitleOpListener null");
        }
        titleOpListener = listener;
    };

    var checkMoveMotion = false;
    titleLeft.addEventListener("touchstart",function(){
        event.stopPropagation();
        checkMoveMotion = false;
        moveOverCheck.start(event);
    },false);
    titleLeft.addEventListener("touchmove",function(){
        event.stopPropagation();
        if(moveOverCheck.check(event)) {
            checkMoveMotion = true;
        }
    },false);
    titleLeft.addEventListener("touchend",function(){
        event.stopPropagation();
        if(!checkMoveMotion && titleOpListener){
            checkMoveMotion = false;
            //说法示例
            titleOpListener(0);
            //记录稽核
            exec("LogComponents", "addCmccLog", [cpaCode.speechCase]);
        }
    },false);

    titleRight.addEventListener("touchstart",function(){
        event.stopPropagation();
        checkMoveMotion = false;
        moveOverCheck.start(event);
    },false);
    titleRight.addEventListener("touchmove",function(){
        event.stopPropagation();
        if(moveOverCheck.check(event)) {
            checkMoveMotion = true;
        }
    },false);
    titleRight.addEventListener("touchend",function(){
        event.stopPropagation();
        if(!checkMoveMotion && titleOpListener){
            checkMoveMotion = false;
            //置顶
            titleOpListener(1);
        }
    },false);

    return mainTitle;
}

function onResourceLoadFinish(){
    var titleDiv = createCardMainTitleLocal("nav_local", "常用功能", '“打电话给老爸”',titleResponseListener, false);
    titleRoot.appendChild(titleDiv);
    createLocalView();
    localCardRoot.showContentPage = showContentPage;
    //记录加载时间
    exec("WidgetMMPContainerComponents" , "LocalPageLoadFinish" , []);
}

xcssParser.parseStyleFile("file:///android_asset/local/business.x.css", onResourceLoadFinish);
