var ic_speech_enhance_logo = "file:///android_asset/local/img/ic_speech_enhance_logo.png";
var ic_speech_enhance_spread = "file:///android_asset/local/img/ic_speech_enhance_spread.png";
var ic_speech_enhance_fold = "file:///android_asset/local/img/ic_speech_enhance_fold.png";
var ic_speech_enhance_tip = "file:///android_asset/local/img/ic_speech_enhance_tip.png";

var default_speech_enhance_data = {
  "id": "default",
  "content": "“你好！我是未来世界的超能灵犀，需要我帮你做点什么？”",
  "wordings": [{"content": "“打电话给老妈”"},{"content": "“今天天气怎么样”"},{"content": "“每天8点提醒我起床”"}]  
};

function createSpeechEnhanceView(){
    var speech_case_fold_state = false;
    if(speechEnhanceInfo && speechEnhanceInfo.speechEnhanceCache) {
        default_speech_enhance_data = speechEnhanceInfo.speechEnhanceCache;
    }
    
    var enhanceCard = document.createElement("div");
    enhanceCard.className = "speech_enhance_card";
    
    enhanceCard.addEventListener("touchmove", function(){
        if(speech_case_fold_state) {
            event.preventDefault();
        }
    });
    
    var title_area = document.createElement("div");
    title_area.className = "speech_enhance_card_title";
    
    var title_logo = document.createElement("img");
    title_logo.className = "speech_enhance_title_logo";
    title_logo.src = ic_speech_enhance_logo;
    
    var title_text = document.createElement("div");
    if(default_speech_enhance_data.content.length > 30) {
        title_text.innerHTML = default_speech_enhance_data.content.substring(0,30);
    }else{
        title_text.innerHTML = default_speech_enhance_data.content;
    }
    title_text.className = "speech_enhance_title_text";
    
    var title_spead = document.createElement("div");
    title_spead.className = "speech_enhance_card_spead";
    title_spead.style.backgroundImage = "url('" + ic_speech_enhance_spread + "')";
    if(default_speech_enhance_data.self_show_tip && !speechEnhanceInfo.isFirstUse) {
        var speech_tip = document.createElement("div");
        speech_tip.className = "speech_enhance_card_tip";
        speech_tip.style.backgroundImage = "url('" + ic_speech_enhance_tip + "')";
        title_spead.appendChild(speech_tip);
        
        title_spead.clickTip = function(){
            speech_tip.style.display = "none";
        };
    }
    
    title_area.appendChild(title_logo);
    title_area.appendChild(title_text);
    title_area.appendChild(title_spead);
    
    enhanceCard.appendChild(title_area);

    var case_area = document.createElement("div");
    case_area.className = "speech_enhance_card_case";
    var speech_compute_screen_width = resultDevice.screenWidth;
    if(!speech_compute_screen_width) {
        speech_compute_screen_width = speechEnhanceInfo.webviewWidth;
    }
    
    if(speech_compute_screen_width == 720) {
        var comput_case_area_height = speechEnhanceInfo.webviewHeight - (160 + 72*scale);
        case_area.style.height = comput_case_area_height + "px";
    }else{
        var comput_case_area_height = speechEnhanceInfo.webviewHeight - (71 + 72)*scale;
        case_area.style.height = comput_case_area_height + "px";
    }
    
    var case_length = default_speech_enhance_data.wordings.length;
    if(case_length > 3) {
        case_length = 3;
    }
    
    var case_content = document.createElement("div");
    case_content.className = "speech_enhance_card_case_content";
    
    var case_tip = document.createElement("div");
    case_tip.className = "speech_enhance_card_case_tip";
    case_tip.innerHTML = "你可以这样说：";
    
    case_content.appendChild(case_tip);
    
    for(var i=0; i<case_length; i++) {
        var speech_case = document.createElement("div");
        if(i !== 0) {
            speech_case.className = "speech_enhance_card_case_line";
        }
        speech_case.innerHTML = default_speech_enhance_data.wordings[i].content;

        case_content.appendChild(speech_case);
    }
    
    case_area.appendChild(case_content);
    enhanceCard.appendChild(case_area);
    
    var fold_area = document.createElement("div");
    fold_area.className = "speech_enhance_card_fold";
    
    var fold_ic = document.createElement("div");
    fold_ic.className = "speech_enhance_card_fold_btn";
    fold_ic.innerHTML = "我知道了";
    fold_area.appendChild(fold_ic);
    
    enhanceCard.appendChild(fold_area);
    
    if(speechEnhanceInfo && !speechEnhanceInfo.isFirstUse) {
        case_area.style.display = "none";
        fold_area.style.display = "none";
    } else {
        speech_case_fold_state = true;
        
        title_spead.style.backgroundImage = "url('" + ic_speech_enhance_fold + "')";
        enhanceCard.style.height = (speechEnhanceInfo.webviewHeight + 36*scale) + "px";
    }
    var spread_move_action = false;
    title_spead.addEventListener("touchstart",function(){
    	spread_move_action = false;
    }, false);
    title_spead.addEventListener("touchmove",function(){
    	spread_move_action = true;
    }, false);
    title_spead.addEventListener("touchend",function(){
    	console.log("speechEnhance title_spead touchend");
    	//滑动不处理
    	if(spread_move_action) {
    		spread_move_action = false;
    		return;
    	}
        //外部麦克风入口进入，可能会出现这个问题
        if(speechEnhanceInfo.webviewHeight <= 0) {
            var speechEnhanceInfoStr = exec("WidgetMMPContainerComponents", "getSpeechEnhanceInfo", []);
            console.log(speechEnhanceInfoStr);
            speechEnhanceInfo = getResultMessage(speechEnhanceInfoStr);
            if(typeof speechEnhanceInfo !== "object") {
                return;
            }
            
            var speech_compute_screen_width = resultDevice.screenWidth;
            if(!speech_compute_screen_width) {
                speech_compute_screen_width = speechEnhanceInfo.webviewWidth;
            }
            
            if(speech_compute_screen_width == 720) {
                // var comput_case_area_height = speechEnhanceInfo.webviewHeight - (160 + 64*scale);
                var comput_case_area_height = speechEnhanceInfo.webviewHeight - (160 + 72*scale);
                case_area.style.height = comput_case_area_height + "px";
            }else{
                // var comput_case_area_height = speechEnhanceInfo.webviewHeight - (71 + 64)*scale;
                var comput_case_area_height = speechEnhanceInfo.webviewHeight - (71 + 72)*scale;
                case_area.style.height = comput_case_area_height + "px";
            }
        }
        if(speech_case_fold_state === false) {
            //滚动到顶部
            document.body.scrollTop = 0;
            case_area.style.display = "block";
            fold_area.style.display = "block";
            title_spead.style.backgroundImage = "url('" + ic_speech_enhance_fold + "')";
            
            speech_case_fold_state = true;
            
            enhanceCard.style.height = (speechEnhanceInfo.webviewHeight + 36*scale) + "px";
            if(default_speech_enhance_data.self_show_tip) {
                default_speech_enhance_data.self_show_tip = false;
                if(title_spead.clickTip) {
                    title_spead.clickTip();
                }
                exec("WidgetMMPContainerComponents", "speechEnhanceClick", [default_speech_enhance_data.id, "spread"]);
            }
            
            exec("LogComponents", "addCmccLog", ["LX_100055"]);
            exec("LogComponents", "addLog", [{"code":"FT69302", "extend":{"d_position":"unfold"}}]);
        } else {
            foldClickListener();
            
            exec("LogComponents", "addLog", [{"code":"FT69302", "extend":{"d_position":"fold"}}]);
        }
    }, false);
    
    var foldClickListener = function(){
        case_area.style.display = "none";
        fold_area.style.display = "none";
        title_spead.style.backgroundImage = "url('" + ic_speech_enhance_spread + "')";
        enhanceCard.style.height = "";
        speech_case_fold_state = false;
    };
    
    var fold_move_action = false;
    fold_ic.addEventListener("touchstart",function(){
        fold_move_action = false;
    }, false);
    fold_ic.addEventListener("touchmove",function(){
        fold_move_action = true;
    }, false);
    fold_ic.addEventListener("touchend",function(){
    	console.log("speechEnhance fold_ic touchend");
    	if(fold_move_action) {
    		fold_move_action = false;
    		return;
    	}
        foldClickListener();
        exec("LogComponents", "addLog", [{"code":"FT69302", "extend":{"d_position":"fold"}}]);
    }, false);
    
    if(!speechEnhanceDom) {
        console.log("speechEnhanceDom init get is null, so reget it.");
        speechEnhanceDom = document.getElementById("speech_enhance");
    }
    if(speechEnhanceDom) {
        speechEnhanceDom.showContentPage = foldClickListener;
    }
    document.getElementById("speech_enhance").appendChild(enhanceCard);
    return enhanceCard;
}

xcssParser.parseStyleFile("file:///android_asset/local/speech_css.x.css", createSpeechEnhanceView);